// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', ['ionic', 'starter.controllers', 'ionic-datepicker', 'services'])

/*.run(function($ionicPlatform) {
})*/
 .run(['$ionicPlatform', '$rootScope', '$location', '$timeout', '$ionicHistory', '$cordovaKeyboard', '$state', '$http', '$ionicPopup', '$ionicLoading', 'ls', 'sqlite', 'appConfig', function ($ionicPlatform, $rootScope, $location, $timeout, $ionicHistory, $cordovaKeyboard, $state, $http, $ionicPopup, $ionicLoading, ls, sqlite, appConfig) {

        $ionicPlatform.ready(function () {
            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            }
            if (window.StatusBar) {
                // org.apache.cordova.statusbar required
                StatusBar.styleLightContent();
            }

            /*if (cordova.platformId == 'android') {
                StatusBar.backgroundColorByHexString("#FFF");
            }*/

            navigator.splashscreen.hide();

            function onSuccess(position) {
                $rootScope.position.latitude = position.coords.latitude;
                $rootScope.position.longitude = position.coords.longitude;
                $http.jsonp(url + "/api/app/geocoder_v2.php?location=" + position.coords.latitude + ',' + position.coords.longitude + "&callback=JSON_CALLBACK").success(function(data) {
                    var cityname = data.result.addressComponent.city;
                    if (cityname != '') {
                        $rootScope.location = { sid: data.sid, www: data.www, name: cityname };
                        ls.setObject('city', { sid: data.sid, www: data.www, name: cityname });
                    };
                });
            };

            function onError(error) {
                //
            };

            getLocation = function() {
                if (navigator.geolocation) {
                    navigator.geolocation.getCurrentPosition(onSuccess, onError, { maximumAge: 3000, timeout: 5000, enableHighAccuracy: true });
                };
            };

            if (ls.isNull(location.sid)) {
                getLocation();
            };

        });

        var needLoginView = [
                              "mycenter", 
                              "mycenter_feedback", 
                              "phone_verification", 
                              "activity_details", 
                              "news_details", 
                              "around_choose", 
                              "pay", 
                              "comment_add", 
                              "comment_done", 
                              "mycenter_mydesigndetails",
                              "mycenter_mydesignarounddetails", 
                              "mycenter_mydesigndriftdetails",
                              "mycenter_mydesign",
                              "demand_choose",
                              "drift_choose", 
                              "design_driftdetails",
                              "design_drift",
                              "design_arounddetails",
                              "design_around",
                              "design_tripdetails",
                              "design_trip",
                              "design_tripview",
                              "trip_choose",
                              "usermessages",
                              "usermessages_list"];
        $rootScope.$on('$stateChangeStart',function(event, toState, toParams, fromState, fromParams, options){
          if (toState.name == 'index') {
            //判断是否首次运行
            /*var isFirstRun = appConfig.isFirstRun();
            if (isFirstRun == "true") {
              $state.go('first');
              event.preventDefault();
            };*/
          };
          $rootScope.fromState = needLoginView.indexOf(toState.name)>=0 ? toState.name : "mycenter";
          $rootScope.fromParams = needLoginView.indexOf(toState.name)>=0 ? toParams : {};
          if(needLoginView.indexOf(toState.name) >= 0){
            //判断是否登录
            var isLogin = ls.get('islogin');
            if (isLogin != "true") {
              if (typeof(Wechat) == "undefined") {
                $state.go("login_common");
              }
              else {
                Wechat.isInstalled(function (installed) {
                  if (installed) {
                    $state.go("login");
                  }
                  else {
                    $state.go("login_common");
                  };
                    //alert("Wechat installed: " + (installed ? "Yes" : "No"));
                }, function (reason) {
                    //alert("Failed: " + reason);
                });
              };
              event.preventDefault();
            };
          };
          if (!ls.isNull($rootScope.wxcode)) {
            //加载微信用户数据
            waiting.show($ionicLoading);
            $http.jsonp(url + '/api/app/wxauth.php?code=' + $rootScope.wxcode + '&lang=' + $rootScope.wxlang + '&callback=JSON_CALLBACK').success(function(data) {
                waiting.hide($ionicLoading);
                if (data.code == "1") {
                    var member = {
                        userid: data.userid,
                        nickname: data.nickname,
                        headimgurl: data.headimgurl,
                        phone: data.phone
                    };
                    ls.setObject('member', member);
                    ls.set('access_token', data.access_token);
                    ls.set('expires_in', data.expires_in);
                    ls.set('islogin', true);
                    sqlite.saveData({ member: member, access_token: data.access_token, expires_in: data.expires_in, islogin: true });
                    $rootScope.wxcode = '';
                    $rootScope.wxlang = '';
                    //location.replace(location.href);
                    //$state.go($rootScope.fromState);
                    //window.location.reload();
                    $state.go($state.current, $rootScope.fromParams, {reload: true});
                } else {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: data.strmsg,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    alertPopup.then(function(res) {
                        
                    });
                }
            });
          };
        });

        //物理返回按钮控制&双击退出应用
        /*$ionicPlatform.registerBackButtonAction(function (e) {
            //判断处于哪个页面时双击退出
            if ($location.path() == '/index'||$location.path() == '/mycenter'|| $location.path() == '/login') {
                if ($rootScope.backButtonPressedOnceToExit) {
                    ionic.Platform.exitApp();
                } else {
                    $rootScope.backButtonPressedOnceToExit = true;
                    $cordovaToast.showShortBottom('再按一次退出系统');
                    setTimeout(function () {
                        $rootScope.backButtonPressedOnceToExit = false;
                    }, 2000);
                }
            }else if ($ionicHistory.backView()) {
                if ($cordovaKeyboard.isVisible()) {
                    $cordovaKeyboard.close();
                } else {
                    $ionicHistory.goBack();
                }
            }
            else {
                $rootScope.backButtonPressedOnceToExit = true;
                $cordovaToast.showShortBottom('再按一次退出系统');
                setTimeout(function () {
                    $rootScope.backButtonPressedOnceToExit = false;
                }, 2000);
            }
            e.preventDefault();
            return false;
        }, 101);*/
}])
.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {
  $ionicConfigProvider.platform.ios.tabs.style('standard'); 
  $ionicConfigProvider.platform.ios.tabs.position('bottom');
  $ionicConfigProvider.platform.android.tabs.style('standard');
  $ionicConfigProvider.platform.android.tabs.position('standard');

  $ionicConfigProvider.platform.ios.navBar.alignTitle('center'); 
  $ionicConfigProvider.platform.android.navBar.alignTitle('bottom');//默认为left
  $ionicConfigProvider.backButton.previousTitleText(false);
  $ionicConfigProvider.backButton.text('');

  $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
  $ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');        
  $ionicConfigProvider.platform.ios.views.transition('ios');
  $ionicConfigProvider.views.swipeBackEnabled(false);
  $ionicConfigProvider.platform.android.views.transition('android');
  //$ionicConfigProvider.platform.android.navBar.alignTitle('center');  
  //$ionicConfigProvider.tabs.position('bottom');  
  $stateProvider
  .state('index', {
    cache:false,
    url: '/index',
    templateUrl: 'templates/index.html',
    controller: 'IndexCtrl'
  })
  .state('first', {
    url: '/first',
    templateUrl: 'templates/first.html',
    controller: 'FirstCtrl'
  })
  .state('trip', {
    url: '/trip?designer_level&haoping&renqi',
    templateUrl: 'templates/trip.html',
    controller: 'TripCtrl'
  })
  .state('trip_details', {
    url: '/trip_details?id',
    templateUrl: 'templates/trip_details.html',
    controller: 'TripDetailsCtrl'
  })
  .state('trip_choose', {
    url: '/trip_choose?id',
    templateUrl: 'templates/trip_choose.html',
    controller: 'TripOrderCtrl'
  })
  .state('pay', {
    url: '/pay',
    templateUrl: 'templates/pay.html',
    controller: 'PayCtrl'
  })
  .state('pay_confirm', {
    url: '/pay_confirm',
    templateUrl: 'templates/pay_confirm.html',
    controller: 'PayCtrl'
  })
  .state('pay_success', {
    url: '/pay_success',
    templateUrl: 'templates/pay_success.html',
    controller: 'PayCtrl'
  })
  .state('pay_failed', {
    url: '/pay_failed',
    templateUrl: 'templates/pay_failed.html',
    controller: 'PayCtrl'
  })
  .state('schedule', {
    url: '/schedule',
    templateUrl: 'templates/schedule.html',
    controller: 'ScheduleCtrl'
  })
  .state('schedule_details', {
    url: '/schedule_details?id&user',
    templateUrl: 'templates/schedule_details.html',
    controller: 'ScheduleDetailsCtrl'
  })
  .state('schedule_details_example', {
    url: '/schedule_details_example',
    templateUrl: 'templates/schedule_details.html',
    controller: 'ScheduleExampleCtrl'
  })
  .state('mycenter', {
    cache:false,
    url: '/mycenter',
    templateUrl: 'templates/mycenter.html',
    controller: 'MycenterCtrl'
  })
  .state('mycenter_edit', {
    url: '/mycenter_edit',
    templateUrl: 'templates/mycenter_edit.html',
    controller: 'MycenterCtrl'
  })
  .state('mycenter_designforme', {
    cache:false,
    url: '/mycenter_designforme?type',
    templateUrl: 'templates/mycenter_designforme.html',
    controller: 'MycenterdesignformeCtrl'
  })
  .state('mycenter_bgimage', {
    url: '/mycenter_bgimage',
    templateUrl: 'templates/mycenter_bgimage.html',
    controller: 'MycenterbgimageCtrl'
  })
  .state('mycenter_mydesign', {
    url: '/mycenter_mydesign',
    templateUrl: 'templates/mycenter_mydesign.html',
    controller: 'MydesignCtrl'
  })
  .state('mycenter_mydesigndetails', {
    url: '/mycenter_mydesigndetails?id',
    templateUrl: 'templates/mycenter_mydesigndetails.html',
    controller: 'MydesigndetailsCtrl'
  })
  .state('mycenter_mydesignarounddetails', {
    url: '/mycenter_mydesignarounddetails?id',
    templateUrl: 'templates/mycenter_mydesignarounddetails.html',
    controller: 'MydesigndetailsCtrl'
  })
  .state('mycenter_mydesigndriftdetails', {
    url: '/mycenter_mydesigndriftdetails?id',
    templateUrl: 'templates/mycenter_mydesigndriftdetails.html',
    controller: 'MydesigndetailsCtrl'
  })
  .state('mycenter_mydesigngrabdetails', {
    url: '/mycenter_mydesigngrabdetails?id',
    templateUrl: 'templates/mycenter_mydesigngrabdetails.html',
    controller: 'MydesigndetailsCtrl'
  })
  .state('mycenter_statement', {
    url: '/mycenter_statement',
    templateUrl: 'templates/mycenter_statement.html',
    controller: 'MycenterCtrl'
  })
  .state('mycenter_help', {
    url: '/mycenter_help',
    templateUrl: 'templates/mycenter_help.html',
    controller: 'MycenterCtrl'
  })
  .state('mycenter_feedback', {
    url: '/mycenter_feedback',
    templateUrl: 'templates/mycenter_feedback.html',
    controller: 'MycenterFeedbackCtrl'
  })
  .state('mycenter_aboutus', {
    url: '/mycenter_aboutus',
    templateUrl: 'templates/mycenter_aboutus.html',
    controller: 'MycenterCtrl'
  })
  .state('mycenter_update', {
    url: '/mycenter_update',
    templateUrl: 'templates/mycenter_update.html',
    controller: 'MycenterCtrl'
  })
  .state('design_trip', {
    url: '/design_trip?id&orderid&keywords',
    templateUrl: 'templates/design_trip.html',
    controller: 'DesignCtrl'
  })
  .state('design_tripdetails', {
    url: '/design_tripdetails?id&orderid&index',
    templateUrl: 'templates/design_tripdetails.html',
    controller: 'DesigndetailsCtrl'
  })
  .state('design_tripview', {
    url: '/design_tripview',
    templateUrl: 'templates/design_tripview.html',
    controller: 'DesignCtrl'
  })
  .state('design_around', {
    cache:false,
    url: '/design_around?id&orderid&keywords',
    templateUrl: 'templates/design_around.html',
    controller: 'DesignaroundCtrl'
  })
  .state('design_arounddetails', {
    url: '/design_arounddetails?id&orderid&index',
    templateUrl: 'templates/design_arounddetails.html',
    controller: 'DesignarounddetailsCtrl'
  })
  .state('design_drift', {
    cache:false,
    url: '/design_drift?id&orderid&keywords',
    templateUrl: 'templates/design_drift.html',
    controller: 'DesigndriftCtrl'
  })
  .state('design_driftdetails', {
    url: '/design_driftdetails?id&orderid&index',
    templateUrl: 'templates/design_driftdetails.html',
    controller: 'DesigndriftdetailsCtrl'
  })
   .state('comment_add', {
    url: '/comment_add?id',
    templateUrl: 'templates/comment_add.html',
    controller: 'CommentCtrl'
  })
  .state('comment_done', {
    url: '/comment_done?comment_id&orderid',
    templateUrl: 'templates/comment_done.html',
    controller: 'CommentCtrl'
    })
  .state('login', {
    cache:false,
    url: '/login',
    templateUrl: 'templates/login.html',
    controller: 'LoginCtrl'
  })
  .state('login_common', {
    cache:false,
    url: '/login_common',
    templateUrl: 'templates/login_common.html',
    controller: 'LoginCtrl'
  })
  .state('login_message', {
    cache:false,
    url: '/login_message',
    templateUrl: 'templates/login_message.html',
    controller: 'LoginCtrl'
  })
  .state('register', {
    url: '/register',
    templateUrl: 'templates/register.html',
    controller: 'RegisterCtrl'
  })
  .state('around', {
    url: '/around?designer_level&haoping&renqi',
    templateUrl: 'templates/around.html',
    controller: 'AroundCtrl'
  })
  .state('around_details', {
    url: '/around_details?id',
    templateUrl: 'templates/around_details.html',
    controller: 'AroundDetailsCtrl'
  })
  .state('around_choose', {
    url: '/around_choose?id',
    templateUrl: 'templates/around_choose.html',
    controller: 'AroundOrderCtrl'
  })
  .state('drift_choose', {
    url: '/drift_choose',
    templateUrl: 'templates/drift_choose.html',
    controller: 'DriftOrderCtrl'
  })
  .state('news', {
    url: '/news',
    templateUrl: 'templates/news.html',
    controller: 'NewsCtrl'
  })
  .state('news_details', {
    url: '/news_details?id',
    templateUrl: 'templates/news_details.html',
    controller: 'NewsDetailsCtrl'
  })
  .state('article_details', {
    url: '/article_details?id',
    templateUrl: 'templates/news_details.html',
    controller: 'ArticleDetailsCtrl'
  })
  .state('activity', {
    url: '/activity',
    templateUrl: 'templates/activity.html',
    controller: 'ActivityCtrl'
  })
  .state('activity_details', {
    url: '/activity_details?id',
    templateUrl: 'templates/news_details.html',
    controller: 'ActivityDetailsCtrl'
  })
  .state('location', {
    url: '/location?id',
    templateUrl: 'templates/location.html',
    controller: 'LocationCtrl'
  })
  .state('location_province', {
    url: '/location_province?page&backcount',
    templateUrl: 'templates/location_province.html',
    controller: 'LocationProvinceCtrl'
  })
  .state('usermessages', {
    url: '/usermessages',
    templateUrl: 'templates/usermessages.html',
    controller: 'UserMessagesCtrl'
  })
  .state('usermessages_list', {
    url: '/usermessages_list',
    templateUrl: 'templates/usermessages_list.html',
    controller: 'UserMessagesListCtrl'
  })
  .state('phone_verification', {
    url: '/phone_verification',
    templateUrl: 'templates/mycenter-phone.html',
    controller: 'PhoneVerificationCtrl'
  })
  .state('demand_choose', {
    url: '/demand_choose',
    templateUrl: 'templates/demand_choose.html',
    controller: 'DemandCtrl'
  })
  .state('grab_list', {
    url: '/grab_list',
    templateUrl: 'templates/grab_list.html',
    controller: 'GrabCtrl'
  })
  .state('grab_details', {
    url: '/grab_details?id',
    templateUrl: 'templates/grab_details.html',
    controller: 'GrabDetailsCtrl'
  })
  .state('peek_list', {
    url: '/peek_list',
    templateUrl: 'templates/peek_list.html',
    controller: 'PeekCtrl'
  });
  // if none of the above states are matched, use this as the fallback
  
  if (window.localStorage['ver'] == '1.1.13') {
    $urlRouterProvider.otherwise('/index');
  }
  else {
    window.localStorage['ver'] = "1.1.13";
    $urlRouterProvider.otherwise('/first');
  };
  //$urlRouterProvider.otherwise('/index');
});