var ALERT_TITLE = '系统提示';
var BUTTON_TEXT_CLOSE = '关闭';
var LOADINGTPL = '<p class="apploading"><ion-spinner icon="lines"></ion-spinner>加载中...</p>';
var WAITINGTPL = '<p class="apploading"><ion-spinner icon="lines"></ion-spinner>请等待...</p>';
var url = "http://www.zyrlx.com";
var HTTP_TIMEOUT = 10000;
var TEXT_STATUS_TIMEOUT = "服务器连接超时，请稍后再试。";
var TEXT_STATUS_ERROR = "网络异常，请检查网络服务状态。";
var FPLN = 12; //熟悉目的地个数
var TLN = new Array(6, 6, 6, 9, 12); //行程目的地个数
var version = "2.2.0";

var loading = {
    show: function($ionicLoading) {
        $ionicLoading.show({
            noBackdrop: true,
            template: LOADINGTPL
        });
    },
    hide: function($ionicLoading) {
        $ionicLoading.hide();
    }
};

var waiting = {
    show: function($ionicLoading) {
        $ionicLoading.show({
            noBackdrop: true,
            template: WAITINGTPL
        });
    },
    hide: function($ionicLoading) {
        $ionicLoading.hide();
    }
};

angular.module('starter.controllers', ['ngCordova', 'ngIOS9UIWebViewPatch', 'monospaced.elastic', 'angularMoment', 'ngTouch'])
    .directive('hideTabs', function($rootScope) {
        return {
            restrict: 'A',
            link: function(scope, element, attributes) {
                scope.$on('$ionicView.beforeEnter', function() {
                    scope.$watch(attributes.hideTabs, function(value) {
                        $rootScope.hideTabs = value;
                        $('#self_class').hide();
                        //$('#self_class').removeClass('gjl_index_foot');
                    });
                });

                scope.$on('$ionicView.beforeLeave', function() {
                    $rootScope.hideTabs = false;
                    $('#self_class').show();
                });
            }
        };
    })
    //首页
    .controller('IndexCtrl', function($window, $scope, $rootScope, $http, $ionicSlideBoxDelegate, $ionicPopup, $ionicLoading, $state, $cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $timeout, ls, sqlite, $ionicHistory) {
        sqlite.loadData();
        //sqlite.loadVersion();
        var access_token = ls.get('access_token');
        $rootScope.isLogin = ls.get('islogin') ? true : false;

        $ionicHistory.nextViewOptions({
            disableBack: false
        });

        $scope.$on('$ionicView.beforeEnter', function() {
            $scope.grab_list();
        });

        $scope.$on('$ionicView.enter', function() {
            $rootScope.hideTabs = false;
            $("#self_class").show();
            $ionicSlideBoxDelegate.loop(true);
        });

        $ionicHistory.clearHistory();

        $http.jsonp(url+'/api/app/get_slides.php?callback=JSON_CALLBACK').success(function(data) {
            $scope.slides = data;
            $ionicSlideBoxDelegate.update(); 
        });

        $scope.doRefresh = function() {
            $scope.grab_list();
        };
        $scope.data = { designer_level: 1 };
        //偷看列表
        $scope.peek_list = function() {
            $scope.noData = true;
            $scope.isNull = false;
            $scope.items = [];
            //loading.show($ionicLoading);
            $http.jsonp(url + '/api/app/plans.php?action=hot&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                var list = data.list;
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].planid) == 'undefined') {
                        $scope.isNull = true;
                        $scope.noData = true;
                        $scope.nodata = '您想要的设计师/规划师正在努力修炼中….';
                        break;
                    }
                    list[i].headimgurl = list[i].headimgurl ? list[i].headimgurl : 'images/touxiang.jpg';
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    $scope.noData = false;
                }
                console.log(list);
                $scope.$broadcast('scroll.refreshComplete');
                loading.hide($ionicLoading);
            });
        };
        //抢单列表首页
        $scope.grab_list = function() {
                var page = 1;
                var PAGESIZE = 20;
                var obj = {};
                obj.params = {};
                obj.params.page = page;
                obj.params.pagesize = PAGESIZE;
                $scope.grabisNull = false;
                $scope.grabitems = [];
                loading.show($ionicLoading);
                $http.jsonp(url + '/api/app/order.php?action=singlegrablist&callback=JSON_CALLBACK', obj).success(function(result) {
                    var list = result.list;
                    console.log(list);
                    for (var i = 0; i < list.length; i++) {
                        if (typeof(list[i].userid) == 'undefined') {
                            $scope.grabisNull = true;
                            $scope.grabnodata = '陛下，恕微臣无能，暂未找到已发布的需求！';
                            break;
                        }
                    }
                    if (!$scope.grabisNull) {
                        $scope.grabitems = list;
                    }
                    $scope.$broadcast('scroll.refreshComplete');
                    loading.hide($ionicLoading);
                });
            }
            //抢单
        $scope.grab = function(orderid) {
            //waiting.show($ionicLoading);
            var confirmPopup = $ionicPopup.confirm({
                title: ALERT_TITLE,
                template: "抢单成功后要及时设计行程，您确定要抢单吗？",
                okText: '确定',
                okType: 'button-balanced',
                cancelText: '取消'
            });
            confirmPopup.then(function(res) {
                if (res) {
                    $scope.data = [];
                    $scope.data.orderid = orderid;
                    $.ajax({
                        url: url + '/api/app/order.php?action=singlegrab&access_token=' + access_token + '&orderid=' + orderid,
                        type: 'post',
                        timeout: HTTP_TIMEOUT,
                        async: true,
                        data: $scope.data,
                        dataType: 'json',
                        complete: function(XMLHttpRequest, status) {
                            //waiting.hide($ionicLoading);
                        },
                        success: function(data) {
                            var alertPopup = $ionicPopup.alert({
                                title: ALERT_TITLE,
                                template: data.strmsg,
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                            if (data.code == "1") {
                                alertPopup.then(function(res) {
                                    $rootScope.notdesigner = 0;
                                    $rootScope.notdesignertitle = '我要设计详情';
                                    $state.go('mycenter_mydesigngrabdetails', { id: orderid });
                                });
                            };
                        },
                        error: function(XMLHttpRequest, textStatus, errorThrown) {
                            var text;
                            text = textStatus;
                            if (textStatus == 'timeout') {
                                text = TEXT_STATUS_TIMEOUT;
                            };
                            if (textStatus == 'error') {
                                text = TEXT_STATUS_ERROR;
                            };
                            var alertPopup = $ionicPopup.alert({
                                title: ALERT_TITLE,
                                template: text,
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                        }
                    });
                } else {
                    console.log('You are not sure');
                }
            });
        };
        //偷看
        $scope.pay = function(obj) {
            var data = {
                planid: obj.planid,
                ordertype: 'ordercopy',
                userid: obj.userid,
                nickname: obj.nickname,
                title: obj.title,
                headimgurl: obj.headimgurl,
                price: obj.price,
                keywords: obj.keywords
            };
            $rootScope.pay = data;
            $state.go('pay');
        };
        //查看
        $scope.schedule_details = function(id) {
            $state.go('schedule_details', { id: id });
        };
        $scope.trip_details = function(id) {
            $state.go('trip_details', { id: id });
        };
        //选择达人
        $scope.trip_filter = function() {
            $state.go('trip');
        };
        //周边玩乐
        $scope.around_filter = function() {
            $state.go('around');
        };
        //发布需求
        $scope.demand_choose = function() {
            $state.go('demand_choose');
        };
        $scope.article_details = function(id) {
            $state.go('article_details', { id: id });
        };
        //不知道去哪？
        $scope.drift_choose = function() {
            $state.go('drift_choose');
        };
        //偷看
        $scope.peek = function() {
            $state.go('peek_list');
        };
        //日程
        $scope.schedule = function() {
            $state.go('schedule');
        };
        $scope.slideHasChanged = function(index) {
            $scope.slideIndex = index;
            console.log(index);
        };

        function isIOSWebView(userAgent) {
            return /(iPhone|iPad|iPod)/.test(userAgent);
        }

        function isAndroidWebView(userAgent) {
            return /(Android)/.test(userAgent);
        }

        $http.jsonp(url + "/api/app/ver.php?v=" + version + "&callback=JSON_CALLBACK").success(function(data) {
            if (data.code == "1") {
                var confirmPopup = $ionicPopup.confirm({
                    title: '版本更新',
                    template: data.strmsg,
                    okText: '下载更新',
                    okType: 'button-balanced',
                    cancelText: '下一次'
                });
                confirmPopup.then(function(res) {
                    if (res) {
                        if (isIOSWebView($window.navigator.userAgent)) {
                            window.open(data.url, '_system', 'location=yes');
                        } else {
                            $ionicLoading.show({
                                template: "已经下载：0%"
                            });
                            var targetPath = cordova.file.externalRootDirectory + "Download/ziyouren.apk";

                            var trustHosts = true;
                            var options = {};
                            $cordovaFileTransfer.download(data.url, targetPath, options, trustHosts).then(function(result) {
                                $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive').then(function() {
                                    //成功
                                }, function(err) {
                                    //错误
                                });
                                $ionicLoading.hide();
                            }, function(err) {
                                //alert('下载失败');
                                var ipConfirm = $ionicPopup.confirm({
                                    title: '下载失败',
                                    template: "本地下载失败，是否前往应用宝下载APP？",
                                    okText: '是',
                                    okType: 'button-balanced',
                                    cancelText: '否'
                                });
                                ipConfirm.then(function(res) {
                                    if (res) {
                                        window.open('http://app.qq.com/#id=detail&appid=1105923496', '_system', 'location=yes');
                                    }
                                });
                                $ionicLoading.hide();
                            }, function(progress) {
                                //进度，这里使用文字显示下载百分比
                                $timeout(function() {
                                    var downloadProgress = (progress.loaded / progress.total) * 100;
                                    $ionicLoading.show({
                                        template: "已经下载：" + Math.floor(downloadProgress) + "%"
                                    });
                                    if (downloadProgress > 99) {
                                        $ionicLoading.hide();
                                    }
                                });
                            });
                        };
                    } else {
                        //
                    }
                });
            };
        });

        var location = $rootScope.location || {};
        $rootScope.location = $rootScope.location || { name: '选择周边目的地', sid: '', www: '' };
        $rootScope.position = {
            latitude: '',
            longitude: ''
        };

        function onSuccess(position) {
            $rootScope.position.latitude = position.coords.latitude;
            $rootScope.position.longitude = position.coords.longitude;
            //console.log($rootScope.position);
            $http.jsonp(url + "/api/app/geocoder_v2.php?location=" + position.coords.latitude + ',' + position.coords.longitude + "&callback=JSON_CALLBACK").success(function(data) {
                var cityname = data.result.addressComponent.city;
                if (cityname != '') {
                    $rootScope.location = { sid: data.sid, www: data.www, name: cityname };
                    ls.setObject('city', { sid: data.sid, www: data.www, name: cityname });
                };
            });
        };

        function onError(error) {
            /*$rootScope.cityname = '选择目的地';
            $ionicPopup.alert({
                title: ALERT_TITLE,
                template: '定位失败。 code: ' + error.code + ', message: ' + error.message,
                buttons: [{
                    text: BUTTON_TEXT_CLOSE,
                    type: 'button-balanced'
                }]
            });*/

        };
        getLocation = function() {
            if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(onSuccess, onError, { maximumAge: 3000, timeout: 5000, enableHighAccuracy: true });
            }
        };
        if (ls.isNull(location.sid)) {
            //getLocation();
        };
    })
    //引导页
    .controller('FirstCtrl', function($window, $scope, $stateParams, $state, appConfig) {
        $scope.$on('$ionicView.beforeEnter', function() {
            //
        });

        function isIOSWebView(userAgent) {
            return /(iPhone|iPad|iPod)/.test(userAgent);
        }

        if (isIOSWebView($window.navigator.userAgent)) {
            appConfig.setFirstRun("false");
        }

        $scope.goIndex = function() {
            $state.go('index');
        };
    })
    //行程列表
    .controller('TripCtrl', function($scope, $rootScope, $ionicLoading, $http, $ionicPopup, $stateParams, $state, ls, sqlite) {
        var access_token = ls.get('access_token');
        var hp = typeof($rootScope.HP) == 'undefined' ? '' : $rootScope.HP; //目的地
        $rootScope.hptext = '选择目的地';

        var page = 1;
        var PAGESIZE = 20;

        var obj = {};
        obj.params = {};
        obj.params.page = page;
        obj.params.pagesize = PAGESIZE;
        $scope.items = [];

        $scope.$on('$ionicView.enter', function() {
            hp = typeof($rootScope.HP) == 'undefined' ? '' : $rootScope.HP; //目的地

            if ($rootScope.detailShow) {
                $rootScope.detailShow = false;
                return false;
            };
            $scope.refresh();
        });

        init_Trip = function() {
            obj.params.page = page = 1;
            obj.params.hp = hp;
            $scope.isNull = false;
            $scope.isMore = false;
            $scope.moredata = false;
            $scope.items = [];
        };

        $scope.changeDesigner_level = function(obj) {
            $scope.designer_level = obj;
            $scope.change();
        };

        $scope.changeHaoping = function(obj) {
            $scope.haoping = obj;
            $scope.change();
        };

        $scope.changeRenqi = function(obj) {
            $scope.renqi = obj;
            $scope.change();
        };

        $scope.change = function() {
            obj.params.designer_level = $scope.designer_level;
            obj.params.haoping = $scope.haoping;
            obj.params.renqi = $scope.renqi;
            $scope.refresh();
        };

        $scope.refresh = function() {
            init_Trip();
            loading.show($ionicLoading);
            $http.jsonp(url + '/api/app/designer.php?action=list&typeid=5&access_token=' + access_token + '&callback=JSON_CALLBACK', obj).success(function(result) {
                var list = result.list;
                console.log(list);
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].userid) == 'undefined') {
                        $scope.isNull = true;
                        $scope.isMore = false;
                        $scope.moredata = false;
                        $scope.nodata = '陛下，恕微臣无能，暂未找到与您的目的地匹配的设计师，臣当竭尽全力为你寻找！选择别的目的地也不错哟';
                        break;
                    }
                    list[i].headimgurl = list[i].headimgurl ? list[i].headimgurl : 'images/touxiang.jpg';
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    if (list.length == PAGESIZE) {
                        $scope.isMore = true;
                        $scope.moredata = true;
                        page++;
                    } else {
                        $scope.isMore = false;
                        $scope.moredata = false;
                    }
                }
                $scope.$broadcast('scroll.refreshComplete');
                loading.hide($ionicLoading);
            });
        }

        $scope.loadMore = function() {
            if (!$scope.moredata) return;
            loading.show($ionicLoading);
            obj.params.page = page;
            $http.jsonp(url + '/api/app/designer.php?action=list&typeid=5&access_token=' + access_token + '&callback=JSON_CALLBACK', obj).success(function(result) {
                var list = result.list;
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].userid) == 'undefined') {
                        break;
                    } else {
                        $scope.items.push(list[i]);
                    }
                };
                if (list.length == PAGESIZE) {
                    $scope.isMore = true;
                    $scope.moredata = true;
                    page++;
                } else {
                    $scope.isMore = false;
                    $scope.moredata = false;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                loading.hide($ionicLoading);
            });
        };


        /*var designer_level = typeof($stateParams.designer_level) == 'undefined' ? '0' : $stateParams.designer_level;
        var haoping = typeof($stateParams.haoping) == 'undefined' ? '0' : $stateParams.haoping;
        var renqi = typeof($stateParams.renqi) == 'undefined' ? '0' : $stateParams.renqi;
        //sqlite.loadData();
        var access_token = ls.get('access_token');
        var hp = typeof($rootScope.HP) == 'undefined' ? '' : $rootScope.HP; //目的地
        //$rootScope.hptext = hp ? hp : '选择目的地';
        $rootScope.hptext = '选择目的地';
        //var location = $rootScope.location || {};
        $scope.$on('$ionicView.enter', function() {
            getlist();
        });
        
        $scope.doRefresh = function() {
            getlist();
        };

        function getlist() {
            $scope.noData = true;
            $scope.isNull = false;
            $scope.items = [];
            loading.show($ionicLoading);
            $http.jsonp(url + '/api/app/designer.php?action=list&typeid=5&access_token=' + access_token + '&hp=' + hp + '&level=' + designer_level + '&haoping=' + haoping + '&renqi=' + renqi + '&callback=JSON_CALLBACK').success(function(data) {
                var list = data.list;
                console.log(list);
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].userid) == 'undefined') {
                        $scope.isNull = true;
                        $scope.noData = true;
                        $scope.nodata = '陛下，恕微臣无能，暂未找到与您的目的地匹配的设计师，臣当竭尽全力为你寻找！选择别的目的地也不错哟';
                        break;
                    }
                    list[i].headimgurl = list[i].headimgurl ? list[i].headimgurl : 'images/touxiang.jpg';
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    $scope.noData = false;
                }
                $scope.$broadcast('scroll.refreshComplete');
                loading.hide($ionicLoading);
            });
        };
        $scope.prams = {
            page: 1,
            limit: 20
        };
        $scope.more = true;
        $scope.loadMore = function() {
            try {
                http.jsonp(url + '/api/app/designer.php?action=list&typeid=5&access_token=' + access_token + '&hp=' + hp + '&level=' + designer_level + '&haoping=' + haoping + '&renqi=' + renqi + '&callback=JSON_CALLBACK').success(function(data) {
                    angular.forEach(data.list, function(item) {
                        $scope.items.push(item);
                    });
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.prams.page++;
                });
            } catch (ex) {
                $scope.more = false;
                console.log('loadMore');
            }
        };
        $scope.designer_level = designer_level ? designer_level : '0';
        $scope.haoping = haoping ? haoping : '0';
        $scope.renqi = renqi ? renqi : '0';
        $scope.trip_filter = function(designer_level, haoping, renqi) {
            //console.log(designer_level);console.log(haoping);console.log(renqi);
            $scope.designer_level = designer_level;
            $scope.haoping = haoping;
            $scope.renqi = renqi;
            $state.go('trip', { designer_level: designer_level, haoping: haoping, renqi: renqi });
        };*/
        $scope.trip_details = function(id) {
            $state.go('trip_details', { id: id });
        };
        $scope.location_province = function() {
            $state.go('location_province', { page: 'trip', backcount: '-1' });
        }
        $scope.get_filter = function(name) {
            var search = window.location.hash;
            search = search.substr(search.indexOf('?'));
            var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
            var r = search.substr(1).match(reg);
            if (r != null) return unescape(r[2]);
            return null;
        }

    })
    //设计师详情
    .controller('TripDetailsCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicActionSheet, $ionicSlideBoxDelegate, $http, $state, $stateParams, ls, sqlite) {
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var access_token = ls.get('access_token');
        var member = [];
        member = ls.getObject('member');
        $rootScope.detailShow = true;
        waiting.show($ionicLoading);
        $http.jsonp(url + '/api/app/designer.php?action=show&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
            waiting.hide($ionicLoading);
            data.bgimage = data.bgimage ? data.bgimage : 'images/des_bg.jpg'; //背景图片默认判别
            $scope.data = data;
            $scope.tags = data.tags.split(',');
            $scope.familiar_places = data.familiar_places.split(',');
            console.log(data);
            $ionicSlideBoxDelegate.update();

        });
        $scope.plans = [];
        $scope.items = [];
        $scope.noData = true;
        $scope.isNull = false;
        $http.jsonp(url + '/api/app/plans.php?action=designer&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
            waiting.hide($ionicLoading);
            var list = data.list;
            console.log(list);
            for (var i = 0; i < list.length; i++) {
                if (typeof(list[i].title) == 'undefined' || list[i].title == '') {
                    $scope.isNull = true;
                    $scope.nodata = '您想要的设计师/规划师正在努力修炼中….';
                    break;
                }
            }
            if (!$scope.isNull) {
                $scope.plans = list;
                $scope.nodata = '';
            }
            $scope.isNull = false;
            $ionicSlideBoxDelegate.update();
        });
        setTimeout(getComments(), 5000);
        $scope.doRefresh = function() {
            getComments();
        };

        function getComments() {
            $http.jsonp(url + '/api/app/rating.php?action=list&userid=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                var list = data.list;
                console.log(list);
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].orderid) == 'undefined') {
                        $scope.isNull = true;
                        $scope.noData = true;
                        $scope.cnodata = '暂未收到评价，宝宝还在等…..';
                        break;
                    }
                    list[i].headimgurl = list[i].headimgurl ? list[i].headimgurl : 'images/touxiang.jpg';
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    $scope.noData = false;
                    $scope.cnodata = '';
                }
                $scope.isNull = false;
                $scope.$broadcast('scroll.refreshComplete');
            });

        };
        $scope.prams = {
            page: 2,
            limit: 5
        };
        $scope.nomore = false;
        $scope.loadMore = function() {
            try {
                $http.jsonp(url + '/api/app/rating.php?action=list&userid=' + $scope.data.userid + '&page=' + $scope.prams.page + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                    angular.forEach(data.list, function(item) {
                        if (item.null != 1) {
                            console.log(item);
                            $scope.items.push(item);
                        } else {
                            $scope.nomore = true;
                        };
                    });
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.prams.page++;
                });
            } catch (ex) {
                $scope.nomore = true;
                console.log('loadMore');
            }
        };
        $scope.showShareChoices = function() {
            var hideSheet = $ionicActionSheet.show({
                buttons: [{
                    text: '分享给 <b>好友</b>'
                }, {
                    text: '分享到 <b>朋友圈</b>'
                }],
                titleText: '微信分享',
                cancelText: '取 消',
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    WechatShare(index);
                    return true;
                }
            });
        };
        WechatShare = function(index) {
            Wechat.share({
                message: {
                    title: "我是旅行达人，给你完美旅行线路，帮你轻松挣钱！—自由人旅行",
                    description: "个性化旅行服务平台，最专业的旅行设计师为您量身定制专属行程。",
                    thumb: "www/images/share_thumb.jpg",
                    media: {
                        type: Wechat.Type.LINK,
                        webpageUrl: url + "/download/"
                    }
                },
                scene: index == 0 ? Wechat.Scene.SESSION : Wechat.Scene.TIMELINE
            }, function() {
                //
            }, function(reason) {
                /*var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: "Failed: " + reason,
                        buttons: [{text: BUTTON_TEXT_CLOSE,type: 'button-balanced'}]
                });*/
            });
        };
        $scope.pay = function(obj) {
            var data = {
                planid: obj.planid,
                ordertype: 'ordercopy',
                userid: obj.userid,
                nickname: obj.nickname,
                title: obj.title,
                headimgurl: obj.headimgurl,
                price: obj.price,
                keywords: obj.keywords
            };
            $rootScope.pay = data;
            $state.go('pay');
        };
        $scope.comment_done = function(id) {
            //$state.go('comment_done', { id: id });
        };

        $scope.usermessages = function(userid, nickname, headimgurl) {
            $rootScope.toUser = {
                _id: userid,
                pic: headimgurl,
                username: nickname
            }
            if (typeof(member.headimgurl) == 'undefined') {
                member.userid = '10008';
                member.headimgurl = 'images/touxiang.jpg';
                member.nickname = 'cheng';
            };
            $rootScope.user = {
                _id: member.userid,
                pic: member.headimgurl,
                username: member.nickname
            }
            console.log($rootScope.toUser);
            console.log($rootScope.user);
            if (userid == member.userid) {
                window.plugins.toast.showShortBottom('不可以给自己发送消息喔！', function() {}, function(error) {});
            } else {
                $state.go('usermessages');
            }
        };
        $scope.trip_choose = function(id) {
            if (id == member.userid) {
                window.plugins.toast.showShortBottom('不可以自己预订自己喔！', function() {}, function(error) {});
            } else {
                $state.go('trip_choose', { id: id });
            }
        };
        $scope.random = function() {
            return Math.ceil(Math.random() * 4);
        };
    })
    //行程需求
    .controller('TripOrderCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $http, $stateParams, $state, $ionicHistory, ls, sqlite, ionicDatePicker, $filter, $ionicScrollDelegate, $timeout, $location) {
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var access_token = ls.get('access_token');
        var HP = typeof($rootScope.HP) == 'undefined' ? '' : $rootScope.HP;

        //sqlite.loadData();
        //$rootScope.location = $rootScope.location || { name: '选择目的地', sid: '', www: '' };
        var location = $rootScope.location || {};

        //var location = $rootScope.location || {};
        /*$scope.current = {
            name: location.name,
            sid: location.sid,
            www: location.www
        };*/
        $scope.$on('$ionicView.enter', function() {
            loadData();
        });
        $scope.isShowMore = false;
        $scope.city = '';
        waiting.show($ionicLoading);
        $http.jsonp(url + '/api/app/designer.php?action=show&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
            waiting.hide($ionicLoading);
            $ionicSlideBoxDelegate.update();
            data.cfd = '';
            //data.mdd = [location.name];
            data.days = 0;
            data.adults = 1;
            data.kids = 0;
            data.budget = 0;
            data.isuntime = true;
            data.headimgurl = data.headimgurl ? data.headimgurl : 'images/touxiang.jpg';
            $scope.data = data;
            $scope.data.mdd = HP || '';
            $scope.data.keywords = '';
            $scope.familiar_places = data.familiar_places.split(',');
            console.log($scope.data);
        });
        //城市选择
        $scope.searchEmptyShow = false; //是否显示清除输入的图标
        $scope.showMiddle = false; //是否在屏幕中央显示选中的字母索引
        var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        $scope.indexs = [];
        for (var i = 0; i < chars.length; i++) {
            $scope.indexs.push(chars.charAt(i)); //获取字母数组
        }
        $scope.name = '';
        $scope.startDot = function() { //判断清除输入框的图标是否显示
            if ($scope.name.length = 0 || $scope.name == "") {
                $scope.searchEmptyShow = false;
            } else {
                $scope.searchEmptyShow = true;
            }
        };
        $scope.searchEmpty = function() { //点击清除输入框的图标的点击事件
            $scope.searchEmptyShow = false;
            $scope.name = "";
        };
        $scope.mTouch = function(c) {
            $scope.showMiddle = true;
            $scope.hint = c;
            $location.hash("city_" + $scope.hint);
            $ionicScrollDelegate.anchorScroll(true); //方式2
        };
        $scope.mRelease = function() {
            $timeout(function() {
                $scope.showMiddle = false;
            }, 300);
        };

        function loadData() { //从本地的一个包含全国各城市的json文件中加载数据
            $http.get("data/city.json").success(function(data) {
                $scope.cityDatas = data;
                $ionicLoading.hide();
            });
        }
        $scope.changeCity = function(obj) {
            if ($scope.field == 'cfd') {
                $scope.data.cfd = obj.name;
            } else {
                $scope.data.mdd = obj.name;
            };

            $scope.cityModal.hide();
        };
        $ionicModal.fromTemplateUrl('templates/city_modal.html', function($ionicModal) {
            $scope.cityModal = $ionicModal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });
        $scope.openModal = function(field) {
            $scope.field = field;
            $scope.cityModal.show();
        };
        $scope.closeModal = function() {
            $scope.cityModal.hide();
        };
        $scope.$on('$destroy', function() {
            $scope.cityModal.remove();
        });
        //主题选择
        $ionicModal.fromTemplateUrl('templates/keywords_modal.html', function($ionicModal) {
            $scope.keywordsModal = $ionicModal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });

        function getKeywords() {
            $http.get("data/keywords.json").success(function(result) {
                $scope.keywords = new Array();
                for (var i = 0; i < result.length; i++) {
                    var str = $scope.data.keywords || '';
                    $scope.keywords[i] = new Array();
                    $scope.keywords[i]['text'] = result[i];
                    $scope.keywords[i]['checked'] = str.indexOf(result[i]) == -1 ? false : true;
                };
            });
        }
        $scope.openKeywordsModal = function() {
            getKeywords();
            $scope.keywordsModal.show();
        };
        $scope.closeKeywordsModal = function() {
            $scope.keywordsModal.hide();
        };
        $scope.$on('$destroy', function() {
            $scope.keywordsModal.remove();
        });
        $scope.keywordsChange = function(index) {
            var k = $scope.keywords[index];
            var str = $scope.data.keywords;
            var keywords = $scope.data.keywords.split(',');

            if (k.checked) {
                if (keywords.length == 4) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: '旅游主题最多选择4个。',
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    removeItem(k, str, keywords);
                    $scope.keywords[index].checked = false;
                } else {
                    addItem(k, str, keywords);
                };
            } else {
                removeItem(k, str, keywords);
            };

        };

        function addItem(k, str, keywords) {
            if (str.indexOf(k.text) == -1) {
                for (var i in keywords) {
                    if (keywords[i].length == 0) keywords.splice(i, 1);
                }
                keywords.push(k.text);
                $scope.data.keywords = keywords.join(',');
            };
        };

        function removeItem(k, str, keywords) {
            if (str.indexOf(k.text) > -1) {
                for (var i in keywords) {
                    if (keywords[i] == k.text) {
                        keywords.splice(i, 1);
                        break;
                    };
                    if (keywords[i].length == 0) keywords.splice(i, 1);
                }
            };
            $scope.data.keywords = keywords.join(',');
        };

        $scope.add = function() {
            $scope.data.designerid = $scope.data.userid;
            $scope.data.typeid = 5;
            $scope.data.title = $scope.data.mdd + "目的地游玩";
            //$scope.data.mdd = HP;

            $scope.isDisabled = true;
            waiting.show($ionicLoading);
            $.ajax({
                url: url + '/api/app/wxpay.php?access_token=' + access_token + '&callback=JSON_CALLBACK',
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    waiting.hide($ionicLoading);
                    $scope.isDisabled = false;
                },
                success: function(data) {
                    console.log(data);
                    if (data.code == "0") {
                        var alertPopup = $ionicPopup.alert({
                            title: ALERT_TITLE,
                            template: data.strmsg,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                        });
                    } else {
                        var parameters = {
                            mch_id: data.mch_id,
                            prepay_id: data.prepay_id,
                            nonce: data.nonce_str,
                            timestamp: data.timestamp,
                            sign: data.sign
                        };
                        console.log(parameters);
                        Wechat.sendPaymentRequest(parameters, function() {
                            //
                            var alertPopup = $ionicPopup.alert({
                                title: ALERT_TITLE,
                                template: '支付成功',
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                            alertPopup.then(function(res) {
                                $ionicHistory.goBack(-3);
                            });
                        }, function(reason) {
                            //
                        });
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

        var ipObj1 = {
            callback: function(val) {
                $scope.data.starttime = $filter('date')(new Date(val), 'yyyy-MM-dd');
                $scope.starttime = val;
            },
            disabledDates: [

            ],
            titleLabel: '',
            from: new Date(),
            to: new Date().setYear(new Date().getFullYear() + 1),
            inputDate: new Date(),
            mondayFirst: false,
            //disableWeekdays: [0],
            closeOnSelect: false,
            dateFormat: 'yyyy-MM-dd',
            showTodayButton: true,
            templateType: 'modal'
        };
        var ipObj2 = {
            callback: function(val) {
                $scope.data.endtime = $filter('date')(new Date(val), 'yyyy-MM-dd');
                $scope.endtime = val;
                var date = $scope.endtime - $scope.starttime;
                var days = Math.floor(date / (24 * 3600 * 1000));
                $scope.data.days = days;
            },
            disabledDates: [

            ],
            titleLabel: '',
            from: new Date(),
            to: new Date().setYear(new Date().getFullYear() + 1),
            inputDate: new Date(),
            mondayFirst: false,
            //disableWeekdays: [0],
            closeOnSelect: false,
            dateFormat: 'yyyy-MM-dd',
            showTodayButton: true,
            templateType: 'modal'
        };

        $scope.openDatePicker = function(obj) {
            if (obj == 'starttime') {
                ionicDatePicker.openDatePicker(ipObj1);
                $scope.getprice();
            };
            if (obj == 'endtime') {
                ionicDatePicker.openDatePicker(ipObj2);
                $scope.getprice();
            };
        };
        $scope.getdays = function() {
            var date1 = $scope.data.starttime; //开始时间
            var date2 = $scope.data.endtime; //结束时间
            //console.log(date1);
            var date3 = date2.getTime() - date1.getTime(); //时间差的毫秒数
            var days = Math.floor(date3 / (24 * 3600 * 1000)); //计算出相差天数
            $scope.data.days = days;
            //console.log(days);
        };
        //动态调整价格
        $scope.getprice = function() {
            var days=$scope.data.days;
            var price=0;
            if (days>=1&&days<=2) {
                price=20;
            }else if (days>=3&&days<=4) {
                price=30;
            }else if (days>=5&&days<=6) {
                price=40;
            }else{
                price=50
            };
            $scope.data.price = price;
            //console.log(price);
        };
        $scope.isuntime = function() {
            var isChecked = $scope.data.isuntime;
            if (isChecked) {
                $('.cxts').show();
                $('.gjl_chufa_time').hide();
            } else {
                $('.cxts').hide();
                $('.gjl_chufa_time').show();
            }
        };
        $scope.location_province = function(page) {
            $state.go('location_province', { page: page });
        };
        $scope.show_more = function() {
            $scope.isShowMore = true;
        };
        $scope.hide_more = function() {
            $scope.isShowMore = false;
        };
        $scope.add_mdd = function(name) {
            var str = $scope.data.mdd;
            if (str.indexOf(name) > -1) {
                $scope.data.mdd = str.replace(name + ',', ''); //存在则删除
                var str = $scope.data.mdd;
                if (str.indexOf(name) > -1) {
                    $scope.data.mdd = str.replace(name, '');
                    $scope.data.mdd = $scope.data.mdd.replace(/,$/g, "");
                }
            } else {
                var obj = $scope.data.mdd.split(",");
                if (obj.length >= 5) {
                    $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: '最多可以选择五个目的地喔！',
                        buttons: [{
                            text: BUTTON_TEXT_CLOSE,
                            type: 'button-balanced'
                        }]
                    });
                } else {

                    if ($scope.data.mdd == '') {
                        $scope.data.mdd = $scope.data.mdd + name + ',';
                    } else {
                        $scope.data.mdd = $scope.data.mdd + ',' + name + ',';
                    }
                    $scope.data.mdd = $scope.data.mdd.replace(/,$/g, "");
                }
            }
            console.log($scope.data.mdd);
        };
        $scope.is_have_mdd = function(name) {
            var str = $scope.data.mdd;
            if (str.indexOf(name) > -1) {
                return true;
            } else {
                return false;
            }
        };
    })
    //设计行程
    .controller('DesignCtrl', function($scope, $rootScope, $ionicModal, $ionicPopup, $ionicLoading, $http, $state, $ionicActionSheet, $ionicHistory, sqlite, $stateParams, ls, Camera) {
        var access_token = ls.get('access_token');
        var id = '';
        var orderid = '';
        $rootScope.itinerary = {};
        init();
        $scope.$on('$ionicView.beforeEnter', function() {
            id = typeof($stateParams.id) == 'undefined' ? (typeof($rootScope.planid) == 'undefined' ? '' : $rootScope.planid) : $stateParams.id;
            orderid = typeof($stateParams.orderid) == 'undefined' ? (typeof($rootScope.orderid) == 'undefined' ? '' : $rootScope.orderid) : $stateParams.orderid;
            if (id) {
                getPlan();
            } else {
                //init();
            }
        });

        function getPlan() {
            $http.jsonp(url + '/api/app/plans.php?action=show&user=designer&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                $scope.data.id = data.id;
                $scope.data.budget = data.budget;
                $scope.data.itinerary = data.itinerary;
                if ($scope.data.title == '') {
                    $scope.data.title = data.title;
                };
                console.log(data);
            });
        }

        $scope.addday = function() {
            var obj = {
                rcmc: '',
                rcys: '',
                sj: '',
                cfd: '',
                mdd: '',
                bwjd: '',
                jdtp: '',
                jdwxts: '',
                bcms: '',
                mstp: '',
                mswxts: '',
                jtts: '',
                zstj: '',
            };
            $scope.data.itinerary.push(obj);
        };

        $scope.removeday = function(index, number) {
            var confirmPopup = $ionicPopup.confirm({
                title: ALERT_TITLE,
                template: "您确定要删除这一天行程吗？",
                okText: '确定',
                okType: 'button-balanced',
                cancelText: '取消'
            });
            confirmPopup.then(function(res) {
                if (res) {
                    $scope.data.budget = $scope.data.budget - $scope.data.itinerary[index].rcys;
                    $.get(url + "/api/app/plans.php?action=remove&id=" + id + "&index=" + index + "&access_token=" + access_token, function(result) {});
                    $scope.data.itinerary.splice(index, number);
                } else {
                    console.log('You are not sure');
                }
            });

        };
        //plan初始化
        function init() {
            $scope.data = {
                id: '',
                title: '',
                keywords: $rootScope.keywords,
                budget: 0.00,
                itinerary: [{ rcmc: '', rcys: '', sj: '', cfd: '', mdd: '', bwjd: '', jdtp: '', jdwxts: '', bcms: '', mstp: '', mswxts: '', jtts: '', zstj: '' }],

            };
            console.log($scope.data);
        };

        $scope.design_tripdetails = function(index) {
            $rootScope.itinerary = $scope.data.itinerary[index];
            $state.go('design_tripdetails', { id: id, orderid: orderid, index: index });
        };

        $scope.dosubmit = function() {
            //waiting.show($ionicLoading);
            $scope.data.orderid = orderid;
            $scope.data.typeid = 5;
            $.ajax({
                url: url + '/api/app/plans.php?action=submit&access_token=' + access_token,
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    //waiting.hide($ionicLoading);
                },
                success: function(data) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: data.strmsg,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    if (data.code == "1") {
                        alertPopup.then(function(res) {
                            $ionicHistory.goBack(-2);
                        });
                    };
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

    })
    //设计日程
    .controller('DesigndetailsCtrl', function($scope, $rootScope, $ionicPopup, $ionicLoading, $http, $state, $ionicActionSheet, sqlite, $stateParams, ls, Camera, ionicDatePicker, $filter, $ionicHistory) {
        var access_token = ls.get('access_token');
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var orderid = typeof($stateParams.orderid) == 'undefined' ? '' : $stateParams.orderid;
        var index = typeof($stateParams.index) == 'undefined' ? '' : $stateParams.index;
        var isSave = false;

        $scope.imgItems = { jdtp: [], mstp: [] };
        $scope.imgUrl = { jdtp: [], mstp: [] };

        $scope.data = {
            id: id,
            orderid: orderid,
            index: index,
            keywords: $rootScope.keywords,
            day: $rootScope.itinerary,
        };

        function dayIsEmpty(obj) {
            for (var key in obj) {
                if (obj[key] != '') {
                    return false;
                    //break;
                };
            }
            return true;
        };

        if ($rootScope.itinerary.jdtp) {
            var str = $rootScope.itinerary.jdtp.toString();
            var images = str.split(',');
            for (var key in images) {
                $scope.imgItems.jdtp.push({ imgurl: images[key] });
                $scope.imgUrl.jdtp.push(images[key]);
            }
            $rootScope.itinerary.jdtp = $scope.imgUrl.jdtp;
        };

        if ($rootScope.itinerary.mstp) {
            var str = $rootScope.itinerary.mstp.toString();
            var images = str.split(',');
            for (var key in images) {
                $scope.imgItems.mstp.push({ imgurl: images[key] });
                $scope.imgUrl.mstp.push(images[key]);
            }
            $rootScope.itinerary.mstp = $scope.imgUrl.mstp;
        };

        $scope.day = Number(index) + 1;

        $scope.removeImages = function(obj, index, number) {
            var confirmPopup = $ionicPopup.confirm({
                title: ALERT_TITLE,
                template: "您确定要删除这图片吗？",
                okText: '确定',
                okType: 'button-balanced',
                cancelText: '取消'
            });
            confirmPopup.then(function(res) {
                if (res) {
                    if (obj == 'jdtp') {
                        $scope.imgItems.jdtp.splice(index, number);
                        $scope.imgUrl.jdtp.splice(index, number);
                        $scope.data.day.jdtp = $scope.imgUrl.jdtp;
                    };
                    if (obj == 'mstp') {
                        $scope.imgItems.mstp.splice(index, number);
                        $scope.imgUrl.mstp.splice(index, number);
                        $scope.data.day.mstp = $scope.imgUrl.mstp;
                    };
                }
            });
        };

        $scope.showImageUploadChoices = function(prop) {
            var hideSheet = $ionicActionSheet.show({
                buttons: [{
                    text: '<b>拍照</b> 上传'
                }, {
                    text: '从 <b>相册</b> 中选'
                }],
                titleText: '图片上传',
                cancelText: '取 消',
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    // 相册文件选择上传
                    if (index == 1) {
                        $scope.readalbum(prop);
                    } else if (index == 0) {
                        // 拍照上传
                        $scope.taskPicture(prop);
                    }
                    return true;
                }
            });
        };

        $scope.readalbum = function(prop) {
            var options = {
                quality: 75,
                destinationType: 0,
                sourceType: 0,
                allowEdit: true,
                encodingType: 0,
                targetWidth: 720,
                targetHeight: 720,
                popoverOptions: CameraPopoverOptions,
                //correctOrientation: true,
                saveToPhotoAlbum: false
            };

            Camera.getPicture(options).then(function(imageURI) {
                if (prop == 'jdtp') {
                    $scope.imgItems.jdtp.push({ imgurl: "data:image/jpeg;base64," + imageURI });
                    $scope.imgUrl.jdtp.push(imageURI);
                    $scope.data.day.jdtp = $scope.imgUrl.jdtp;
                };
                if (prop == 'mstp') {
                    $scope.imgItems.mstp.push({ imgurl: "data:image/jpeg;base64," + imageURI });
                    $scope.imgUrl.mstp.push(imageURI);
                    $scope.data.day.mstp = $scope.imgUrl.mstp;
                };
            }, function(err) {
                window.plugins.toast.showShortBottom(err, function() {}, function(error) {});
            });
        };

        $scope.taskPicture = function(prop) {
            var options = {
                quality: 75,
                destinationType: 0,
                sourceType: 1,
                allowEdit: true,
                encodingType: 0,
                targetWidth: 720,
                targetHeight: 720,
                popoverOptions: CameraPopoverOptions,
                //correctOrientation: true,
                saveToPhotoAlbum: false
            };

            Camera.getPicture(options).then(function(imageURI) {
                if (prop == 'jdtp') {
                    $scope.imgItems.jdtp.push({ imgurl: "data:image/jpeg;base64," + imageURI });
                    $scope.imgUrl.jdtp.push(imageURI);
                    $scope.data.day.jdtp = $scope.imgUrl.jdtp;
                };
                if (prop == 'mstp') {
                    $scope.imgItems.mstp.push({ imgurl: "data:image/jpeg;base64," + imageURI });
                    $scope.imgUrl.mstp.push(imageURI);
                    $scope.data.day.mstp = $scope.imgUrl.mstp;
                };
            }, function(err) {
                window.plugins.toast.showShortBottom(err, function() {}, function(error) {});
            });
        };

        var ipObj1 = {
            callback: function(val) {
                $scope.data.day.sj = $filter('date')(new Date(val), 'yyyy-MM-dd');
            },
            disabledDates: [

            ],
            titleLabel: '',
            from: new Date(),
            to: new Date().setYear(new Date().getFullYear() + 1),
            inputDate: new Date(),
            mondayFirst: false,
            //disableWeekdays: [0],
            closeOnSelect: false,
            dateFormat: 'yyyy-MM-dd',
            showTodayButton: true,
            templateType: 'modal'
        };

        $scope.openDatePicker = function() {
            ionicDatePicker.openDatePicker(ipObj1);
        };

        $scope.save = function() {
            //waiting.show($ionicLoading);
            $.ajax({
                url: url + '/api/app/plans.php?action=save&access_token=' + access_token,
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    //waiting.hide($ionicLoading);
                },
                success: function(data) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: data.strmsg,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    if (data.code == "1") {
                        alertPopup.then(function(res) {
                            //$state.go('design_trip', { id: data.id, orderid: orderid });
                            //$rootScope.plan = { id: data.id, orderid: orderid };
                            $rootScope.planid = data.id;
                            $rootScope.orderid = orderid;
                            $ionicHistory.goBack(); //返回上一页
                        });
                    };
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };
    })
    //设计行程(周边)
    .controller('DesignaroundCtrl', function($scope, $rootScope, $ionicModal, $ionicPopup, $ionicLoading, $http, $state, $ionicActionSheet, $ionicHistory, sqlite, $stateParams, ls, Camera) {
        var access_token = ls.get('access_token');
        var id = '';
        var orderid = '';
        $rootScope.itinerary = {};
        init();
        $scope.$on('$ionicView.beforeEnter', function() {
            id = typeof($stateParams.id) == 'undefined' ? (typeof($rootScope.planid) == 'undefined' ? '' : $rootScope.planid) : $stateParams.id;
            orderid = typeof($stateParams.orderid) == 'undefined' ? (typeof($rootScope.orderid) == 'undefined' ? '' : $rootScope.orderid) : $stateParams.orderid;

            if (id) {
                getPlan();
            } else {
                //init();
            }
        });

        function getPlan() {
            $http.jsonp(url + '/api/app/plans.php?action=show&user=designer&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                $scope.data.id = data.id;
                $scope.data.budget = data.budget;
                $scope.data.itinerary = data.itinerary;
                if ($scope.data.title == '') {
                    $scope.data.title = data.title;
                };
                console.log(data);
            });
        }
        $scope.addday = function() {
            var obj = {
                rcmc: '',
                rcys: '',
                mdd: '',
                bwjd: '',
                jdwxts: '',
                bcms: '',
                mswxts: '',
            };
            $scope.data.itinerary.push(obj);
        };

        $scope.removeday = function(index, number) {
            var confirmPopup = $ionicPopup.confirm({
                title: ALERT_TITLE,
                template: "您确定要删除这一天行程吗？",
                okText: '确定',
                okType: 'button-balanced',
                cancelText: '取消'
            });
            confirmPopup.then(function(res) {
                if (res) {
                    $scope.data.budget = $scope.data.budget - $scope.data.itinerary[index].rcys;
                    $.get(url + "/api/app/plans.php?action=remove&id=" + id + "&index=" + index + "&access_token=" + access_token, function(result) {});
                    $scope.data.itinerary.splice(index, number);
                } else {
                    console.log('You are not sure');
                }
            });

        };
        //plan初始化
        function init() {
            $scope.data = {
                id: '',
                title: '',
                keywords: $rootScope.keywords,
                budget: 0.00,
                itinerary: [{ rcmc: '', rcys: '', mdd: '', bwjd: '', jdwxts: '', bcms: '', mswxts: '' }],
            };
        };

        $scope.design_arounddetails = function(index) {
            $rootScope.itinerary = $scope.data.itinerary[index];
            $state.go('design_arounddetails', { id: id, orderid: orderid, index: index });
        };

        $scope.dosubmit = function() {
            //waiting.show($ionicLoading);
            $scope.data.orderid = orderid;
            $scope.data.typeid = 6;
            $.ajax({
                url: url + '/api/app/plans.php?action=submit&access_token=' + access_token,
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    //waiting.hide($ionicLoading);
                },
                success: function(data) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: data.strmsg,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    if (data.code == "1") {
                        alertPopup.then(function(res) {
                            $ionicHistory.goBack(-2);
                        });
                    };
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

    })
    //设计日程(周边)
    .controller('DesignarounddetailsCtrl', function($scope, $rootScope, $ionicPopup, $ionicLoading, $http, $state, sqlite, $stateParams, ls, $ionicHistory) {
        var access_token = ls.get('access_token');
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var orderid = typeof($stateParams.orderid) == 'undefined' ? '' : $stateParams.orderid;
        var index = typeof($stateParams.index) == 'undefined' ? '' : $stateParams.index;
        var isSave = false;

        $scope.data = {
            id: id,
            orderid: orderid,
            index: index,
            keywords: $rootScope.keywords,
            day: $rootScope.itinerary,
        };

        $scope.day = Number(index) + 1;

        $scope.save = function() {
            //waiting.show($ionicLoading);
            $.ajax({
                url: url + '/api/app/plans.php?action=save&access_token=' + access_token,
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    //waiting.hide($ionicLoading);
                },
                success: function(data) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: data.strmsg,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    if (data.code == "1") {
                        alertPopup.then(function(res) {
                            $rootScope.planid = data.id;
                            $rootScope.orderid = orderid;
                            $ionicHistory.goBack(); //返回上一页
                        });
                    };
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };
    })
    //设计行程(无目的地)
    .controller('DesigndriftCtrl', function($scope, $rootScope, $ionicModal, $ionicPopup, $ionicLoading, $http, $state, $ionicActionSheet, $ionicHistory, sqlite, $stateParams, ls, Camera) {
        var access_token = ls.get('access_token');
        var id = '';
        var orderid = '';
        $rootScope.itinerary = {};
        init();
        $scope.$on('$ionicView.beforeEnter', function() {
            id = typeof($stateParams.id) == 'undefined' ? (typeof($rootScope.planid) == 'undefined' ? '' : $rootScope.planid) : $stateParams.id;
            orderid = typeof($stateParams.orderid) == 'undefined' ? (typeof($rootScope.orderid) == 'undefined' ? '' : $rootScope.orderid) : $stateParams.orderid;

            if (id) {
                getPlan();
            } else {
                //init();
            }
        });

        function getPlan() {
            $http.jsonp(url + '/api/app/plans.php?action=show&user=designer&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                $scope.data.id = data.id;
                $scope.data.budget = data.budget;
                $scope.data.itinerary = data.itinerary;
                if ($scope.data.title == '') {
                    $scope.data.title = data.title;
                };
                console.log(data);
            });
        }
        $scope.addday = function() {
            var obj = {
                rcmc: '',
                rcys: '',
                sj: '',
                cfd: '',
                mdd: '',
                bwjd: '',
                jdtp: '',
                jdwxts: '',
                bcms: '',
                mstp: '',
                mswxts: '',
                jtts: '',
                zstj: '',
            };
            $scope.data.itinerary.push(obj);
        };

        $scope.removeday = function(index, number) {
            var confirmPopup = $ionicPopup.confirm({
                title: ALERT_TITLE,
                template: "您确定要删除这一天行程吗？",
                okText: '确定',
                okType: 'button-balanced',
                cancelText: '取消'
            });
            confirmPopup.then(function(res) {
                if (res) {
                    $scope.data.budget = $scope.data.budget - $scope.data.itinerary[index].rcys;
                    $.get(url + "/api/app/plans.php?action=remove&id=" + id + "&index=" + index + "&access_token=" + access_token, function(result) {});
                    $scope.data.itinerary.splice(index, number);
                } else {
                    console.log('You are not sure');
                }
            });

        };
        //plan初始化
        function init() {
            $scope.data = {
                id: '',
                title: '',
                keywords: $rootScope.keywords,
                budget: 0.00,
                itinerary: [{ rcmc: '', rcys: '', sj: '', cfd: '', mdd: '', bwjd: '', jdtp: '', jdwxts: '', bcms: '', mstp: '', mswxts: '', jtts: '', zstj: '' }],
            };
        };

        $scope.design_driftdetails = function(index) {
            $rootScope.itinerary = $scope.data.itinerary[index];
            $state.go('design_driftdetails', { id: id, orderid: orderid, index: index });
        };

        $scope.dosubmit = function() {
            //waiting.show($ionicLoading);
            $scope.data.orderid = orderid;
            $scope.data.typeid = 7;
            $.ajax({
                url: url + '/api/app/plans.php?action=submit&access_token=' + access_token,
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    //waiting.hide($ionicLoading);
                },
                success: function(data) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: data.strmsg,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    if (data.code == "1") {
                        alertPopup.then(function(res) {
                            $ionicHistory.goBack(-2);
                        });
                    };
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

    })
    //设计日程(无目的地)
    .controller('DesigndriftdetailsCtrl', function($scope, $rootScope, $ionicPopup, $ionicLoading, $http, $state, $ionicActionSheet, sqlite, $stateParams, ls, Camera, ionicDatePicker, $filter, $ionicHistory) {
        var access_token = ls.get('access_token');
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var orderid = typeof($stateParams.orderid) == 'undefined' ? '' : $stateParams.orderid;
        var index = typeof($stateParams.index) == 'undefined' ? '' : $stateParams.index;
        var isSave = false;

        $scope.imgItems = { jdtp: [], mstp: [] };
        $scope.imgUrl = { jdtp: [], mstp: [] };

        $scope.data = {
            id: id,
            orderid: orderid,
            index: index,
            keywords: $rootScope.keywords,
            day: $rootScope.itinerary,
        };

        function dayIsEmpty(obj) {
            for (var key in obj) {
                if (obj[key] != '') {
                    return false;
                    //break;
                };
            }
            return true;
        };

        if ($rootScope.itinerary.jdtp) {
            var str = $rootScope.itinerary.jdtp.toString();
            var images = str.split(',');
            for (var key in images) {
                $scope.imgItems.jdtp.push({ imgurl: images[key] });
                $scope.imgUrl.jdtp.push(images[key]);
            }
            $rootScope.itinerary.jdtp = $scope.imgUrl.jdtp;
        };

        if ($rootScope.itinerary.mstp) {
            var str = $rootScope.itinerary.mstp.toString();
            var images = str.split(',');
            for (var key in images) {
                $scope.imgItems.mstp.push({ imgurl: images[key] });
                $scope.imgUrl.mstp.push(images[key]);
            }
            $rootScope.itinerary.mstp = $scope.imgUrl.mstp;
        };

        $scope.day = Number(index) + 1;

        $scope.removeImages = function(obj, index, number) {
            var confirmPopup = $ionicPopup.confirm({
                title: ALERT_TITLE,
                template: "您确定要删除这图片吗？",
                okText: '确定',
                okType: 'button-balanced',
                cancelText: '取消'
            });
            confirmPopup.then(function(res) {
                if (res) {
                    if (obj == 'jdtp') {
                        $scope.imgItems.jdtp.splice(index, number);
                        $scope.imgUrl.jdtp.splice(index, number);
                        $scope.data.day.jdtp = $scope.imgUrl.jdtp;
                    };
                    if (obj == 'mstp') {
                        $scope.imgItems.mstp.splice(index, number);
                        $scope.imgUrl.mstp.splice(index, number);
                        $scope.data.day.mstp = $scope.imgUrl.mstp;
                    };
                }
            });
        };

        $scope.showImageUploadChoices = function(prop) {
            var hideSheet = $ionicActionSheet.show({
                buttons: [{
                    text: '<b>拍照</b> 上传'
                }, {
                    text: '从 <b>相册</b> 中选'
                }],
                titleText: '图片上传',
                cancelText: '取 消',
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    // 相册文件选择上传
                    if (index == 1) {
                        $scope.readalbum(prop);
                    } else if (index == 0) {
                        // 拍照上传
                        $scope.taskPicture(prop);
                    }
                    return true;
                }
            });
        };

        $scope.readalbum = function(prop) {
            var options = {
                quality: 75,
                destinationType: 0,
                sourceType: 0,
                allowEdit: true,
                encodingType: 0,
                targetWidth: 720,
                targetHeight: 720,
                popoverOptions: CameraPopoverOptions,
                //correctOrientation: true,
                saveToPhotoAlbum: false
            };

            Camera.getPicture(options).then(function(imageURI) {
                if (prop == 'jdtp') {
                    $scope.imgItems.jdtp.push({ imgurl: "data:image/jpeg;base64," + imageURI });
                    $scope.imgUrl.jdtp.push(imageURI);
                    $scope.data.day.jdtp = $scope.imgUrl.jdtp;
                };
                if (prop == 'mstp') {
                    $scope.imgItems.mstp.push({ imgurl: "data:image/jpeg;base64," + imageURI });
                    $scope.imgUrl.mstp.push(imageURI);
                    $scope.data.day.mstp = $scope.imgUrl.mstp;
                };
            }, function(err) {
                window.plugins.toast.showShortBottom(err, function() {}, function(error) {});
            });
        };

        $scope.taskPicture = function(prop) {
            var options = {
                quality: 75,
                destinationType: 0,
                sourceType: 1,
                allowEdit: true,
                encodingType: 0,
                targetWidth: 720,
                targetHeight: 720,
                popoverOptions: CameraPopoverOptions,
                //correctOrientation: true,
                saveToPhotoAlbum: false
            };

            Camera.getPicture(options).then(function(imageURI) {
                if (prop == 'jdtp') {
                    $scope.imgItems.jdtp.push({ imgurl: "data:image/jpeg;base64," + imageURI });
                    $scope.imgUrl.jdtp.push(imageURI);
                    $scope.data.day.jdtp = $scope.imgUrl.jdtp;
                };
                if (prop == 'mstp') {
                    $scope.imgItems.mstp.push({ imgurl: "data:image/jpeg;base64," + imageURI });
                    $scope.imgUrl.mstp.push(imageURI);
                    $scope.data.day.mstp = $scope.imgUrl.mstp;
                };
            }, function(err) {
                window.plugins.toast.showShortBottom(err, function() {}, function(error) {});
            });
        };

        var ipObj1 = {
            callback: function(val) {
                $scope.data.day.sj = $filter('date')(new Date(val), 'yyyy-MM-dd');
            },
            disabledDates: [

            ],
            titleLabel: '',
            from: new Date(),
            to: new Date().setYear(new Date().getFullYear() + 1),
            inputDate: new Date(),
            mondayFirst: false,
            //disableWeekdays: [0],
            closeOnSelect: false,
            dateFormat: 'yyyy-MM-dd',
            showTodayButton: true,
            templateType: 'modal'
        };

        $scope.openDatePicker = function() {
            ionicDatePicker.openDatePicker(ipObj1);
        };

        $scope.save = function() {
            //waiting.show($ionicLoading);
            $.ajax({
                url: url + '/api/app/plans.php?action=save&access_token=' + access_token,
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    //waiting.hide($ionicLoading);
                },
                success: function(data) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: data.strmsg,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    if (data.code == "1") {
                        alertPopup.then(function(res) {
                            $rootScope.planid = data.id;
                            $rootScope.orderid = orderid;
                            $ionicHistory.goBack(); //返回上一页
                        });
                    };
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };
    })
    //行程需求(无目的地)
    .controller('DriftOrderCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $http, $stateParams, $state, $ionicHistory, $ionicScrollDelegate, $location, ls, sqlite, ionicDatePicker, $filter) {
        var access_token = ls.get('access_token');

        $scope.data = {
            designerid: 0,
            typeid: 7,
            title: "无目的地游玩",
            bcxq: '',
            tjms: false,
            tjyl: false,
            starttime: '',
            endtime: '',
            days: 1,
            isuntime: true,
            remark: '',
            budget: 0,
            linkman: '',
            linktel: '',
            price: 20,
            keywords: ''
        };

        $scope.$on('$ionicView.enter', function() {
            loadData();
        });

        $scope.searchEmptyShow = false; //是否显示清除输入的图标
        $scope.showMiddle = false; //是否在屏幕中央显示选中的字母索引
        var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        $scope.indexs = [];
        
        for (var i = 0; i < chars.length; i++) {
            $scope.indexs.push(chars.charAt(i)); //获取字母数组
        }
        $scope.name = '';
        $scope.startDot = function() { //判断清除输入框的图标是否显示
            if ($scope.name.length = 0 || $scope.name == "") {
                $scope.searchEmptyShow = false;
            } else {
                $scope.searchEmptyShow = true;
            }
        };
        $scope.searchEmpty = function() { //点击清除输入框的图标的点击事件
            $scope.searchEmptyShow = false;
            $scope.name = "";
        };
        $scope.mTouch = function(c) {
            $scope.showMiddle = true;
            $scope.hint = c;
            $location.hash("city_" + $scope.hint);
            $ionicScrollDelegate.anchorScroll(true); //方式2
        };
        $scope.mRelease = function() {
            $timeout(function() {
                $scope.showMiddle = false;
            }, 300);
        };

        function loadData() { //从本地的一个包含全国各城市的json文件中加载数据
            $http.get("data/city.json").success(function(data) {
                $scope.cityDatas = data;
                $ionicLoading.hide();
            });
        }
        /*$http.get("data/site.json").success(function(result) {
            $scope.hotcities = result.hotcities;
            $scope.allcities = result.allcities;
        });*/

        $scope.changeCity = function(obj) {
            if ($scope.field == 'cfd') {
                $scope.data.cfd = obj.name;
            } else {
                $scope.data.mdd = obj.name;
            };
            $ionicScrollDelegate.scrollTop();
            $scope.cityModal.hide();
        };
        $ionicModal.fromTemplateUrl('templates/city_modal.html', function($ionicModal) {
            $scope.cityModal = $ionicModal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });
        $scope.openModal = function(field) {
            $scope.field = field;
            $scope.cityModal.show();
        };
        $scope.closeModal = function() {
            $scope.cityModal.hide();
        };
        $scope.$on('$destroy', function() {
            $scope.cityModal.remove();
        });
        //主题选择
        $ionicModal.fromTemplateUrl('templates/keywords_modal.html', function($ionicModal) {
            $scope.keywordsModal = $ionicModal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });

        function getKeywords() {
            $http.get("data/keywords.json").success(function(result) {
                $scope.keywords = new Array();
                for (var i = 0; i < result.length; i++) {
                    var str = $scope.data.keywords || '';
                    $scope.keywords[i] = new Array();
                    $scope.keywords[i]['text'] = result[i];
                    $scope.keywords[i]['checked'] = str.indexOf(result[i]) == -1 ? false : true;
                };
            });
        }
        $scope.openKeywordsModal = function() {
            getKeywords();
            $scope.keywordsModal.show();
        };
        $scope.closeKeywordsModal = function() {
            $scope.keywordsModal.hide();
        };
        $scope.$on('$destroy', function() {
            $scope.keywordsModal.remove();
        });
        $scope.keywordsChange = function(index) {
            var k = $scope.keywords[index];
            var str = $scope.data.keywords;
            var keywords = $scope.data.keywords.split(',');
            if (k.checked) {
                if (keywords.length == 4) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: '旅游主题最多选择4个。',
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    removeItem(k, str, keywords);
                    $scope.keywords[index].checked = false;
                } else {
                    addItem(k, str, keywords);
                };
            } else {
                removeItem(k, str, keywords);
            };
        };

        function addItem(k, str, keywords) {
            if (str.indexOf(k.text) == -1) {
                for (var i in keywords) {
                    if (keywords[i].length == 0) keywords.splice(i, 1);
                }
                keywords.push(k.text);
                $scope.data.keywords = keywords.join(',');
            };
        };

        function removeItem(k, str, keywords) {
            if (str.indexOf(k.text) > -1) {
                for (var i in keywords) {
                    if (keywords[i] == k.text) {
                        keywords.splice(i, 1);
                        break;
                    };
                    if (keywords[i].length == 0) keywords.splice(i, 1);
                }
            };
            $scope.data.keywords = keywords.join(',');
        };
        $scope.add = function() {
            $scope.isDisabled = true;
            $scope.data.adults = $scope.data.adults ? $scope.data.adults : 1,
                $scope.data.kids = $scope.data.kids ? $scope.data.kids : 0,
                waiting.show($ionicLoading);
            $.ajax({
                url: url + '/api/app/wxpay.php?access_token=' + access_token + '&callback=JSON_CALLBACK',
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    waiting.hide($ionicLoading);
                    $scope.isDisabled = false;
                },
                success: function(data) {
                    console.log(data);
                    if (data.code == "0") {
                        var alertPopup = $ionicPopup.alert({
                            title: ALERT_TITLE,
                            template: data.strmsg,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                        });
                    } else {
                        var parameters = {
                            mch_id: data.mch_id,
                            prepay_id: data.prepay_id,
                            nonce: data.nonce_str,
                            timestamp: data.timestamp,
                            sign: data.sign
                        };
                        console.log(parameters);
                        Wechat.sendPaymentRequest(parameters, function() {
                            //
                            var alertPopup = $ionicPopup.alert({
                                title: ALERT_TITLE,
                                template: '支付成功',
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                            alertPopup.then(function(res) {
                                $ionicHistory.goBack();
                            });
                        }, function(reason) {
                            //
                        });
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

        var ipObj1 = {
            callback: function(val) {
                $scope.data.starttime = $filter('date')(new Date(val), 'yyyy-MM-dd');
                $scope.starttime = val;
            },
            disabledDates: [

            ],
            titleLabel: '',
            from: new Date(),
            to: new Date().setYear(new Date().getFullYear() + 1),
            inputDate: new Date(),
            mondayFirst: false,
            //disableWeekdays: [0],
            closeOnSelect: false,
            dateFormat: 'yyyy-MM-dd',
            showTodayButton: true,
            templateType: 'modal'
        };
        var ipObj2 = {
            callback: function(val) {
                $scope.data.endtime = $filter('date')(new Date(val), 'yyyy-MM-dd');
                $scope.endtime = val;
                var date = $scope.endtime - $scope.starttime;
                var days = Math.floor(date / (24 * 3600 * 1000));
                $scope.data.days = days;
            },
            disabledDates: [

            ],
            titleLabel: '',
            from: new Date(),
            to: new Date().setYear(new Date().getFullYear() + 1),
            inputDate: new Date(),
            mondayFirst: false,
            //disableWeekdays: [0],
            closeOnSelect: false,
            dateFormat: 'yyyy-MM-dd',
            showTodayButton: true,
            templateType: 'modal'
        };

        $scope.openDatePicker = function(obj) {
            if (obj == 'starttime') {
                ionicDatePicker.openDatePicker(ipObj1);
                $scope.getprice();
            };
            if (obj == 'endtime') {
                ionicDatePicker.openDatePicker(ipObj2);
                $scope.getprice();
            };
        };
        $scope.getdays = function() {
            var date1 = $scope.data.starttime; //开始时间
            var date2 = $scope.data.endtime; //结束时间
            //console.log(date1);
            var date3 = date2.getTime() - date1.getTime(); //时间差的毫秒数
            var days = Math.floor(date3 / (24 * 3600 * 1000)); //计算出相差天数
            $scope.data.days = days;
            //console.log(days);
        };
        //动态调整价格
        $scope.getprice = function() {
            var days=$scope.data.days;
            var price=0;
            if (days>=1&&days<=2) {
                price=20;
            }else if (days>=3&&days<=4) {
                price=30;
            }else if (days>=5&&days<=6) {
                price=40;
            }else{
                price=50
            };
            $scope.data.price = price;
            //console.log(price);
        };
        $scope.isuntime = function() {
            var isChecked = $scope.data.isuntime;
            if (isChecked) {
                $('.cxts').show();
                $('.gjl_chufa_time').hide();
            } else {
                $('.cxts').hide();
                $('.gjl_chufa_time').show();
            }
        };
    })
    //我设计的(列表)
    .controller('MydesignCtrl', function($scope, $rootScope, $ionicPopup, $http, $state, $ionicActionSheet, sqlite, ls, $cordovaCamera, Camera) {
        var access_token = ls.get('access_token');
        $scope.isNull = false;
        $http.jsonp(url + '/api/app/order.php?action=list&user=designer&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
            var list = data.list;
            console.log(list);
            for (var i = 0; i < list.length; i++) {
                if (typeof(list[i].userid) == 'undefined') {
                    $scope.isNull = true;
                    $scope.nodata = '小主，您还没有需要查看的信息哦';
                    break;
                }
            }
            if (!$scope.isNull) {
                $scope.items = list;
            }
        });
        $scope.schedule_details = function(id) {
            $state.go('schedule_details', { id: id, user: 'designer' });
        };
        $scope.mydesigndetails = function(id, typeid) {
            $rootScope.notdesigner = 0;
            $rootScope.notdesignertitle = '我要设计详情';
            if (typeid == 5) {
                $state.go('mycenter_mydesigndetails', { id: id });
            } else if (typeid == 6) {
                $state.go('mycenter_mydesignarounddetails', { id: id });
            } else if (typeid == 7) {
                $state.go('mycenter_mydesigndriftdetails', { id: id });
            } else if (typeid == 8) {
                $state.go('mycenter_mydesigngrabdetails', { id: id });
            };
        };
        $scope.comment_done = function(orderid) {
            $state.go('comment_done', { orderid: orderid });
        };
    })
    //我要设计详情
    .controller('MydesigndetailsCtrl', function($scope, $rootScope, $ionicPopup, $http, $state, $ionicActionSheet, sqlite, $stateParams, ls, $cordovaCamera, Camera) {
        var access_token = ls.get('access_token');
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var member = [];
        member = ls.getObject('member');
        console.log($rootScope.notdesigner);
        if ($rootScope.notdesigner == 1) {
            $http.jsonp(url + '/api/app/order.php?action=show&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                $scope.data = data;
                console.log(data);
            });
        } else {
            $http.jsonp(url + '/api/app/order.php?action=show&user=designer&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                $scope.data = data;
                console.log(data);
            });
        }
        $scope.usermessages = function(userid, nickname, headimgurl) {
            $rootScope.toUser = {
                _id: userid,
                pic: headimgurl,
                username: nickname
            }
            if (typeof(member.headimgurl) == 'undefined') {
                member.userid = '10008';
                member.headimgurl = 'images/touxiang.jpg';
                member.nickname = 'cheng';
            };
            $rootScope.user = {
                _id: member.userid,
                pic: member.headimgurl,
                username: member.nickname
            }
            if (userid == member.userid) {
                window.plugins.toast.showShortBottom('不可以给自己发送消息喔！', function() {}, function(error) {});
            } else {
                $state.go('usermessages');
            }
        };
        $scope.design_trip = function(plan_id, keywords) {
            var plan_id = typeof(plan_id) == 'undefined' ? '' : plan_id;
            plan_id = plan_id == 0 ? '' : plan_id;
            console.log(plan_id);
            $rootScope.keywords = keywords;
            $state.go('design_trip', { id: plan_id, orderid: id });
        };
        $scope.design_around = function(plan_id, keywords) {
            var plan_id = typeof(plan_id) == 'undefined' ? '' : plan_id;
            plan_id = plan_id == 0 ? '' : plan_id;
            console.log(plan_id);
            $rootScope.keywords = keywords;
            $state.go('design_around', { id: plan_id, orderid: id });
        };
        $scope.design_drift = function(plan_id, keywords) {
            var plan_id = typeof(plan_id) == 'undefined' ? '' : plan_id;
            plan_id = plan_id == 0 ? '' : plan_id;
            console.log(plan_id);
            $rootScope.keywords = keywords;
            $state.go('design_drift', { id: plan_id, orderid: id });
        };
    })
    //评论
    .controller('CommentCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $http, $state, $ionicActionSheet, sqlite, $stateParams, ls, $cordovaCamera, Camera) {
        var access_token = ls.get('access_token');
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var comment_id = typeof($stateParams.comment_id) == 'undefined' ? '' : $stateParams.comment_id;
        var orderid = typeof($stateParams.orderid) == 'undefined' ? '' : $stateParams.orderid;
        if (comment_id || orderid) {
            $http.jsonp(url + '/api/app/rating.php?action=show&id=' + comment_id + '&access_token=' + access_token + '&orderid=' + orderid + '&callback=JSON_CALLBACK').success(function(data) {
                $scope.data = data;
                console.log(data);
            });
        };
        $scope.data = {};
        $scope.comment_add = function() {
            $scope.data.orderid = id;
            //$scope.data.userid = $rootScope.order.userid;
            $scope.data.ztpj = $rootScope.ztpj;
            $scope.data.wcsd = $rootScope.wcsd;
            waiting.show($ionicLoading);
            $.ajax({
                url: url + '/api/app/rating.php?action=add&orderid=' + id + '&access_token=' + access_token + '',
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    waiting.hide($ionicLoading);
                },
                success: function(data) {
                    if (data.code == "1") {
                        var alertPopup = $ionicPopup.alert({
                            title: '感谢您的评价',
                            template: data.strmsg,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                        });
                        $state.go('mycenter_designforme');
                        //$state.go('comment_done', { comment_id: data.id });
                    } else {
                        var alertPopup = $ionicPopup.alert({
                            title: ALERT_TITLE,
                            template: data.strmsg,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                        });
                    };
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

    })
    //日程列表
    .controller('ScheduleCtrl', function($scope, $rootScope, $ionicLoading, $http, $ionicPopup, $state, ls) {
        var access_token = ls.get('access_token');
        getlist();
        $scope.doRefresh = function() {
            getlist();
        };

        function getlist() {
            $scope.noData = true;
            $scope.isNull = false;
            $scope.items = [];
            loading.show($ionicLoading);
            $http.jsonp(url + '/api/app/order.php?action=list&status=2,3,5&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                var list = data.list;
                console.log(list);
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].userid) == 'undefined') {
                        $scope.isNull = true;
                        $scope.noData = true;
                        $scope.nodata = '小主，您还没有需要查看的信息哦';
                        break;
                    }
                    list[i].headimgurl = list[i].headimgurl ? list[i].headimgurl : 'images/touxiang.jpg';
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    $scope.noData = false;
                }
                $scope.$broadcast('scroll.refreshComplete');
                loading.hide($ionicLoading);
            });
        };

        $scope.schedule_details = function(id) {
            $state.go('schedule_details', { id: id });
        };
        $scope.schedule_details_example = function() {
            $state.go('schedule_details_example');
        };
    })
    //日程详情
    .controller('ScheduleDetailsCtrl', function($scope, $rootScope, $ionicLoading, $ionicSlideBoxDelegate, $http, $compile, $ionicModal, $ionicPopup, $state, $location, $anchorScroll, $stateParams, ls) {
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var user = typeof($stateParams.user) == 'undefined' ? '' : $stateParams.user;
        var access_token = ls.get('access_token');
        $scope.active = [];
        $scope.slideIndex = 0;

        $scope.$on('$ionicView.beforeEnter', function() {
            //waiting.show($ionicLoading);
            $http.jsonp(url + '/api/app/plans.php?action=show&id=' + id + '&user=' + user + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                $scope.data = data;
                console.log(data);
            });
        });
        $scope.goto = function(maoid) {
            $location.hash(maoid);
            $anchorScroll();
        };
        $scope.slideHasChanged = function(index) {
            $scope.slideIndex = index;
        };
        $scope.slide = function(index) {
            $ionicSlideBoxDelegate.slide(index);
        };

    })
    //日程列子
    .controller('ScheduleExampleCtrl', function($scope, $rootScope, $ionicLoading, $ionicSlideBoxDelegate, $http, $compile, $ionicModal, $ionicPopup, $state, $location, $anchorScroll, $stateParams, ls) {
        var access_token = ls.get('access_token');
        $scope.active = [];
        $scope.slideIndex = 0;

        $scope.$on('$ionicView.beforeEnter', function() {
            //waiting.show($ionicLoading);
            $http.jsonp(url + '/api/app/plans.php?action=example&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                $scope.data = data;
                console.log(data);
            });
        });

        $scope.goto = function(maoid) {
            $location.hash(maoid);
            $anchorScroll();
        };
        $scope.slideHasChanged = function(index) {
            $scope.slideIndex = index;
        };
        $scope.slide = function(index) {
            $ionicSlideBoxDelegate.slide(index);
        };
    })
    //个人中心
    .controller('MycenterCtrl', function($window, $scope, $rootScope, $ionicPopup, $ionicLoading, $cordovaFileTransfer, $cordovaFile, $cordovaFileOpener2, $timeout, $http, $state, $ionicActionSheet, sqlite, ls, $cordovaCamera, Camera, $ionicBackdrop, $ionicHistory, $interval) {
        var memberObj = ls.getObject('member');
        $scope.access_token = ls.get('access_token');
        $scope.data = memberObj;

        /*var description = ""; 
         for(var i in memberObj){ 
         var property=memberObj[i]; 
         description+=i+" = "+property+"\n"; 
         } 
         alert(description);*/

        $scope.$on('$ionicView.beforeEnter', function() {
            /*if (ls.isNull($scope.access_token)) {
                if (ls.isNull($rootScope.wxcode)) {
                    $state.go('login');
                    //$state.go('login_common');
                } else {
                    waiting.show($ionicLoading);
                    $http.jsonp(url + '/api/app/wxauth.php?code=' + $rootScope.wxcode + '&lang=' + $rootScope.wxlang + '&callback=JSON_CALLBACK').success(function(data) {
                        waiting.hide($ionicLoading);
                        if (data.code == "1") {
                            //$.cookie('islogin', true);
                            var member = {
                                userid: data.userid,
                                nickname: data.nickname,
                                headimgurl: data.headimgurl,
                                phone: data.phone
                            };
                            //alert(data.headimgurl);
                            ls.setObject('member', member);
                            ls.set('access_token', data.access_token);
                            ls.set('expires_in', data.expires_in);
                            ls.set('islogin', true);
                            sqlite.saveData({ member: member, access_token: data.access_token, expires_in: data.expires_in, islogin: true });
                            $scope.access_token = data.access_token;
                            $rootScope.wxcode = '';
                            $rootScope.wxlang = '';
                            $scope.data.nickname = data.nickname;
                            $scope.data.headimgurl = data.headimgurl;
                            getinfo();
                        } else {
                            var alertPopup = $ionicPopup.alert({
                                title: ALERT_TITLE,
                                template: data.strmsg,
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                            $timeout(function() {
                                $state.go('login');
                            }, 0, false);
                        }
                    });
                };
            } else {
                getinfo();
            };*/
            getinfo();
        });
        $scope.$on('$ionicView.enter', function() {
            //$scope.data.familiar_places = $rootScope.FP ? $rootScope.FP : $scope.data.familiar_places;
            //
        });

        function getinfo() {
            $http.jsonp(url + '/api/app/user.php?action=getinfo&access_token=' + $scope.access_token + '&callback=JSON_CALLBACK').success(function(data) {
                data.bgimage = data.bgimage ? data.bgimage : 'images/des_bg.jpg'; //背景图片默认判别
                if ($rootScope.mycenter_edit_data) {
                    $scope.data = $rootScope.mycenter_edit_data;
                    $scope.data.familiar_places = $rootScope.FP ? $rootScope.FP : $scope.data.familiar_places;
                } else {
                    $scope.data = data;
                }
                var wxbound = data.wxbound;
                $scope.data.wxbound = !wxbound && typeof(wxbound) != "undefined" ? '' : wxbound;
                if (ls.isNull(memberObj)) {
                    var member = {
                        userid: data.userid,
                        nickname: data.nickname,
                        headimgurl: data.headimgurl,
                        phone: data.phone
                    };
                    ls.setObject('member', member);
                    sqlite.saveData({ member: member });
                };
                $rootScope.phoneVerified = data.phoneverified == '1' ? true : false;
                //$scope.tags = data.tags.split(',');
                $rootScope.FP = $scope.data.familiar_places ? $scope.data.familiar_places : $rootScope.FP;
                $rootScope.FPLN = FPLN[data.designer_level_id];
                //$scope.data.familiar_places = $rootScope.FP ? $rootScope.FP : $scope.data.familiar_places;
                //$rootScope.familiar_places = $scope.data.familiar_places;
                console.log($scope.data);
            });
        };

        $scope.isDisabled = false;
        $scope.sendcodeDisabled = false;

        $scope.bs = '发送验证码';

        $scope.sendcode = function() {
            var regMobile = /^13[0-9]{9}$|14[0-9]{9}$|15[0-9]{9}$|17[0-9]{9}$|18[0-9]{9}$/;

            var p = $scope.data.phone;
            if (p == "") {
                $ionicPopup.alert({
                    title: ALERT_TITLE,
                    template: '请输入手机号。',
                    buttons: [{
                        text: BUTTON_TEXT_CLOSE,
                        type: 'button-balanced'
                    }]
                });
            } else if (!regMobile.test(p)) {
                $ionicPopup.alert({
                    title: ALERT_TITLE,
                    template: '手机号码格式不对。',
                    buttons: [{
                        text: BUTTON_TEXT_CLOSE,
                        type: 'button-balanced'
                    }]
                });
            } else {
                $scope.count = 60;
                var time = $interval(function() {
                    $scope.count--;
                    $scope.sendcodeDisabled = true;
                    $scope.bs = '重发(' + $scope.count + ')';
                    if ($scope.count == 0) {
                        $interval.cancel(time);
                        $scope.sendcodeDisabled = false;
                        $scope.bs = '重发';
                    }
                }, 1000);

                $http.jsonp(url + '/api/app/sendcode.php?phone=' + p + '&callback=JSON_CALLBACK').success(function(data) {
                    if (data.status == "success") {
                        //
                    } else {
                        var info = data.info;
                        $ionicPopup.alert({
                            title: ALERT_TITLE,
                            template: info,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-assertive' }]
                        });
                    }
                });
            }
        };

        $scope.changeinfo = function() {
            console.log($scope.data);
            waiting.show($ionicLoading);
            $.ajax({
                url: url + '/api/app/user.php?action=changeinfo&access_token=' + $scope.access_token,
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    waiting.hide($ionicLoading);
                },
                success: function(data) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: data.strmsg,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    if (data.code == "1") {
                        if ($scope.data.phone != '' && !$rootScope.phoneVerified) {
                            memberObj.phone = $scope.data.phone;
                            ls.setObject('member', memberObj);
                            sqlite.saveData({ member: memberObj });
                        };
                        alertPopup.then(function(res) {
                            $ionicHistory.goBack();
                        });
                    } else {
                        //
                    };
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

        function isIOSWebView(userAgent) {
            return /(iPhone|iPad|iPod)/.test(userAgent);
        }

        function isAndroidWebView(userAgent) {
            return /(Android)/.test(userAgent);
        }
        $scope.version = version;
        $scope.docheck = function() {
            $http.jsonp(url + "/api/app/ver.php?v=" + version + "&callback=JSON_CALLBACK").success(function(data) {
                if (data.code == 0) {
                    var alertPopup = $ionicPopup.alert({
                        title: '版本更新',
                        template: data.strmsg,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    })
                } else {
                    var confirmPopup = $ionicPopup.confirm({
                        title: '版本更新',
                        template: data.strmsg,
                        okText: '下载更新',
                        okType: 'button-balanced',
                        cancelText: '下一次'
                    });
                    confirmPopup.then(function(res) {
                        if (res) {
                            //window.location.href = data.url;
                            //window.open(data.url, '_system', 'location=yes');

                            if (isIOSWebView($window.navigator.userAgent)) {
                                //window.location.href = data.url;
                                window.open(data.url, '_system', 'location=yes');
                            } else {
                                $ionicLoading.show({
                                    template: "已经下载：0%"
                                });

                                var targetPath = cordova.file.externalRootDirectory + "Download/ziyouren.apk";

                                var trustHosts = true;
                                var options = {};
                                $cordovaFileTransfer.download(data.url, targetPath, options, trustHosts).then(function(result) {
                                    $cordovaFileOpener2.open(targetPath, 'application/vnd.android.package-archive').then(function() {
                                        //成功
                                    }, function(err) {
                                        //错误
                                    });
                                    $ionicLoading.hide();
                                }, function(err) {
                                    alert('下载失败');
                                    $ionicLoading.hide();
                                }, function(progress) {
                                    //进度，这里使用文字显示下载百分比
                                    $timeout(function() {
                                        var downloadProgress = (progress.loaded / progress.total) * 100;
                                        $ionicLoading.show({
                                            template: "已经下载：" + Math.floor(downloadProgress) + "%"
                                        });
                                        if (downloadProgress > 99) {
                                            $ionicLoading.hide();
                                        }
                                    });
                                });
                            };
                        } else {
                            //
                        }
                    });
                }
            });
        };

        $scope.logout = function() {
            var confirmPopup = $ionicPopup.confirm({
                title: ALERT_TITLE,
                template: "您确定要退出当前账户吗？",
                okText: '确定',
                okType: 'button-balanced',
                cancelText: '取消'
            });

            confirmPopup.then(function(res) {
                if (res) {
                    ls.set('member', '');
                    ls.set('access_token', '');
                    ls.set('expires_in', '');
                    ls.set('islogin', false);
                    sqlite.saveData({ member: null, access_token: null, expires_in: null, islogin: false });
                    $rootScope.isLogin = false;
                    $state.go('index');
                }
            });
        };

        $scope.showImageUploadChoices = function(prop) {
            var hideSheet = $ionicActionSheet.show({
                buttons: [{
                    text: '<b>拍照</b> 上传'
                }, {
                    text: '从 <b>相册</b> 中选'
                }],
                titleText: '图片上传',
                cancelText: '取 消',
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    // 相册文件选择上传
                    if (index == 1) {
                        $scope.readalbum(prop);
                    } else if (index == 0) {
                        // 拍照上传
                        $scope.taskPicture(prop);
                    }
                    return true;
                }
            });
        };

        $scope.readalbum = function(prop) {
            var options = {
                quality: 75,
                destinationType: 0,
                sourceType: 0,
                allowEdit: true,
                encodingType: 0,
                targetWidth: 720,
                targetHeight: 720,
                popoverOptions: CameraPopoverOptions,
                //correctOrientation: true,
                saveToPhotoAlbum: false
            };

            Camera.getPicture(options).then(function(imageURI) {
                if (prop == 'thumb') {
                    $scope.isThumb = true;
                    $scope.data.thumb = "data:image/jpeg;base64," + imageURI;

                };
                //alert(imageURI);
            }, function(err) {
                alert(err);

            });
        };

        $scope.taskPicture = function(prop) {
            var options = {
                quality: 75,
                destinationType: 0,
                sourceType: 1,
                allowEdit: true,
                encodingType: 0,
                targetWidth: 720,
                targetHeight: 720,
                popoverOptions: CameraPopoverOptions,
                //correctOrientation: true,
                saveToPhotoAlbum: false
            };

            Camera.getPicture(options).then(function(imageURI) {
                if (prop == 'thumb') {
                    $scope.isThumb = true;
                    $scope.data.thumb = "data:image/jpeg;base64," + imageURI;
                    $scope.changeinfo();
                };
                //alert(imageURI);
            }, function(err) {
                alert(err);
            });
        };

        $scope.onThumbTouch = function() {
            $scope.isThumbTouch = true;
        };

        $scope.onThumbRelease = function() {
            $scope.isThumbTouch = false;
            $scope.showImageUploadChoices("thumb");
        };

        $scope.deleteThumb = function() {
            $scope.isThumb = false;
            $scope.data.thumb = "";
        };
        $scope.news = function() {
            $state.go('news');
        };
        $scope.location_province = function(page) {
            $rootScope.mycenter_edit_data = $scope.data;
            $state.go('location_province', { page: page });
        }
        $scope.mycenter_bgimage = function() {
            // 一个确认对话框
            var confirmPopup = $ionicPopup.confirm({
                title: ALERT_TITLE,
                template: '更换背景图片',
                cancelText: '取消', // String (默认: 'Cancel')。一个取消按钮的文字。
                okText: '确定', // String (默认: 'OK')。OK按钮的文字。
            });
            confirmPopup.then(function(res) {
                if (res) {
                    $state.go('mycenter_bgimage');
                } else {
                    console.log('You are not sure');
                }
            });
        };

    })
    .controller('MycenterbgimageCtrl', function($scope, $rootScope, $ionicPopup, $ionicLoading, $http, $state, $ionicActionSheet, sqlite, ls, $ionicHistory) {
        $scope.access_token = ls.get('access_token');
        $scope.changebgimage = function(bgimage) {
            $scope.data = {
                bgimage: bgimage
            };
            console.log($scope.data);
            waiting.show($ionicLoading);
            $.ajax({
                url: url + '/api/app/user.php?action=changebgimage&access_token=' + $scope.access_token,
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    waiting.hide($ionicLoading);
                },
                success: function(data) {
                    if (data.code == "1") {
                        $ionicHistory.goBack();
                    } else {
                        //
                    };
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

    })
    //为我设计(列表)
    .controller('MycenterdesignformeCtrl', function($scope, $rootScope, $stateParams, $ionicLoading, $http, $ionicPopup, $state, ls) {
        var access_token = ls.get('access_token');
        var type = typeof($stateParams.type) == 'undefined' ? '' : $stateParams.type;
        if (type == '') {
            $rootScope.typetitle = '为我设计';
        } else if (type == 'clone') {
            $rootScope.typetitle = '我偷看的';
        }
        order_list(type);
        $scope.doRefresh = function() {
            order_list(type);
        };

        function order_list(type) {
            $scope.noData = true;
            $scope.isNull = false;
            $scope.items = [];
            loading.show($ionicLoading);
            $http.jsonp(url + '/api/app/order.php?action=list&access_token=' + access_token + '&type=' + type + '&callback=JSON_CALLBACK').success(function(data) {
                var list = data.list;
                console.log(list);
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].userid) == 'undefined') {
                        $scope.isNull = true;
                        $scope.noData = true;
                        $scope.nodata = '小主，您还没有需要查看的信息哦';
                        break;
                    }
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    $scope.noData = false;
                }
                $scope.$broadcast('scroll.refreshComplete');
                loading.hide($ionicLoading);
            });
        };
        $scope.comment_add = function(userid, nickname, headimgurl, title, price, orderdate, mdd, id, orderid) {
            $rootScope.order = { userid: userid, nickname: nickname, headimgurl: headimgurl, title: title, price: price, orderdate: orderdate, mdd: mdd, id: id, orderid: orderid }
            $state.go('comment_add', { id: id });
        };
        $scope.comment_done = function(orderid) {
            $state.go('comment_done', { orderid: orderid });
        };
        $scope.pay = function(obj) {
            var data = {
                id: obj.id,
                ordertype: 'orderload',
                userid: obj.userid,
                nickname: obj.nickname,
                title: obj.title,
                headimgurl: obj.headimgurl,
                price: obj.price,
                keywords: obj.keywords
            };
            $rootScope.pay = data;
            $state.go('pay');
        };

        $scope.schedule_details = function(id) {
            $state.go('schedule_details', { id: id });
        };
        $scope.mydesigndetails = function(id, typeid) {
            $rootScope.notdesigner = 1;
            $rootScope.notdesignertitle = '为我设计详情';
            if (typeid == 5) {
                $state.go('mycenter_mydesigndetails', { id: id });
            } else if (typeid == 6) {
                $state.go('mycenter_mydesignarounddetails', { id: id });
            } else if (typeid == 7) {
                $state.go('mycenter_mydesigndriftdetails', { id: id });
            } else if (typeid == 8) {
                $state.go('mycenter_mydesigngrabdetails', { id: id });
            };
        };
    })
    //注册
    .controller('RegisterCtrl', function($scope, $ionicLoading, $ionicPopup, $http, $interval, $state) {

        $scope.data = {
            username: "",
            phone: "",
            password: "",
            repassword: "",
        };

        $scope.isDisabled = false;
        $scope.sendcodeDisabled = false;
        $scope.bs = '获取验证码';

        $scope.sendcode = function() {
            var btn = "#button-send";
            var count = 60;
            var curCount;
            var resetValObj;
            var regMobile = /^13[0-9]{9}$|14[0-9]{9}$|15[0-9]{9}$|17[0-9]{9}$|18[0-9]{9}$/;

            var p = $scope.data.phone;
            if (p == "") {
                $ionicPopup.alert({
                    title: ALERT_TITLE,
                    template: '请输入手机号。',
                    buttons: [{
                        text: BUTTON_TEXT_CLOSE,
                        type: 'button-balanced'
                    }]
                });
            } else if (!regMobile.test(p)) {
                $ionicPopup.alert({
                    title: ALERT_TITLE,
                    template: '手机号码格式不对。',
                    buttons: [{
                        text: BUTTON_TEXT_CLOSE,
                        type: 'button-balanced'
                    }]
                });
            } else {
                $scope.count = 60;
                var time = $interval(function() {
                    $scope.count--;
                    $scope.sendcodeDisabled = true;
                    $scope.bs = '重发(' + $scope.count + ')';
                    if ($scope.count == 0) {
                        $interval.cancel(time);
                        $scope.sendcodeDisabled = false;
                        $scope.bs = '重发';
                    }
                }, 1000);

                $http.jsonp(url + '/api/app/sendcode.php?phone=' + p + '&callback=JSON_CALLBACK').success(function(data) {
                    if (data.status == "success") {
                        //
                    } else {
                        var info = data.info;
                        $ionicPopup.alert({
                            title: ALERT_TITLE,
                            template: info,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-assertive' }]
                        });
                    }
                });
            }
        };

        $scope.dosubmit = function() {
            if (!$scope.data.read == 0) {
                var alertPopup = $ionicPopup.alert({
                    title: ALERT_TITLE,
                    template: '您必须同意注册协议',
                    buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                })
            } else {
                $scope.isDisabled = true;
                waiting.show($ionicLoading);
                $.ajax({
                    url: url + "/api/app/user.php?action=register",
                    type: 'post',
                    timeout: HTTP_TIMEOUT,
                    async: true,
                    data: $scope.data,
                    dataType: 'json',
                    complete: function(XMLHttpRequest, status) {
                        $scope.isDisabled = false;
                        waiting.hide($ionicLoading);
                    },
                    success: function(data) {
                        if (data.code == "1") {
                            var alertPopup = $ionicPopup.alert({
                                title: '恭喜',
                                template: data.strmsg,
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                            $state.go('mycenter');
                        } else {
                            var alertPopup = $ionicPopup.alert({
                                title: ALERT_TITLE,
                                template: data.strmsg,
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                        };
                    },
                    error: function(XMLHttpRequest, textStatus, errorThrown) {
                        var text;
                        text = textStatus;
                        if (textStatus == 'timeout') {
                            text = TEXT_STATUS_TIMEOUT;
                        };
                        if (textStatus == 'error') {
                            text = TEXT_STATUS_ERROR;
                        };
                        var alertPopup = $ionicPopup.alert({
                            title: ALERT_TITLE,
                            template: text,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                        });
                    }
                });
            }
        };

    })
    //登录
    .controller('LoginCtrl', function($scope, $rootScope, $ionicLoading, $ionicPopup, $ionicModal, $http, $state, $timeout, sqlite, ls, $ionicBackdrop, $ionicHistory) {
        var access_token = ls.get('access_token');
        if (!ls.isNull(access_token)) {
            //$state.go('mycenter');
        }
        $scope.data = {
            username: "",
            password: ""
        };
        $ionicBackdrop.release();
        $scope.isread = 1;
        $scope.isDisabled = false;
        /*$ionicHistory.goBack().then(function(){
            console.log("goBack");
            if ($rootScope.fromState == "mycenter") {
                $state.go('index');
                //$rootScope.$ionicGoBack();
            };
        });*/

        $ionicHistory.nextViewOptions({
            disableBack: true
        });
        /*$rootScope.$ionicGoBack = function() {
            $state.go('index');
        };*/
        $scope.goIndex = function() {
            $state.go('index');
        };

        $scope.WxLogin = function() {
            if ($scope.isread != 1) {
                var alertPopup = $ionicPopup.alert({
                    title: ALERT_TITLE,
                    template: '请阅读用户协议',
                    buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                });
            } else {
                window.plugins.toast.showLongBottom("开始微信授权", function() {
                    //waiting.show($ionicLoading);
                    var scope = "snsapi_userinfo",
                        state = "_" + (+new Date());
                    Wechat.auth(scope, state, function(response) {
                        // you may use response.code to get the access token.
                        //alert(JSON.stringify(response));
                        $rootScope.wxcode = response.code;
                        $rootScope.wxlang = response.lang;
                        ls.set('islogin', true);
                        $timeout(function() {
                            //$state.go('mycenter');
                            //$ionicHistory.goBack();
                            $state.go($rootScope.fromState);
                        }, 0, false);

                    }, function(reason) {
                        //waiting.hide($ionicLoading);
                        //window.plugins.toast.showShortBottom("取消了授权", function() {}, function(error) {});
                        //alert("Failed: " + reason);
                    });
                }, function(error) {});
            }
        };
        $scope.doLogin = function(data) {
            $scope.isDisabled = true;
            waiting.show($ionicLoading);
            $.ajax({
                url: url + "/api/app/user.php?action=login",
                type: 'post',
                timeout: HTTP_TIMEOUT,
                // async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    $scope.isDisabled = false;
                    waiting.hide($ionicLoading);
                },
                success: function(data) {
                    if (data.code == "1") {
                        //$.cookie('islogin', true);
                        console.log(data);
                        var member = {
                            userid: data.userid,
                            nickname: data.nickname,
                            headimgurl: data.headimgurl,
                            phone: data.phone
                        };
                        ls.setObject('member', member);
                        ls.set('access_token', data.access_token);
                        ls.set('expires_in', data.expires_in);
                        ls.set('islogin', true);
                        sqlite.saveData({ member: member, access_token: data.access_token, expires_in: data.expires_in, islogin: true });
                        $timeout(function() {
                            console.log('fromState');
                            console.log($rootScope.fromState);
                            $state.go($rootScope.fromState);
                        }, 0, false);

                    } else {
                        var alertPopup = $ionicPopup.alert({
                            title: ALERT_TITLE,
                            template: data.strmsg,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                        });
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

        $scope.checkfn = function() {
            if ($scope.isread == "0") { $scope.isread = 1 } else { $scope.isread = 0 };
            console.log($scope.isread);
        }
        $ionicModal.fromTemplateUrl('yhxyModal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function(modal) {
            $scope.yhxyModal = modal;
        });
        $scope.openyhxyModal = function() {
            $scope.yhxyModal.show();
        };
        $scope.closeyhxyModal = function() {
            $scope.yhxyModal.hide();
        };

    })
    //支付
    .controller('PayCtrl', function($scope, $rootScope, $ionicPopup, $ionicLoading, $http, $state, $stateParams, $ionicHistory, sqlite, ls) {
        var access_token = ls.get('access_token');
        $scope.data = $rootScope.pay;
        $scope.data.planid = typeof($scope.data.planid) == 'undefined' ? '0' : $scope.data.planid;
        $scope.isDisabled = false;

        getComments();
        $scope.doRefresh = function() {
            getComments();
        };

        function getComments() {

            console.log($scope.data.id);
            $http.jsonp(url + '/api/app/rating.php?action=list&planid=' + $scope.data.planid + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                var list = data.list;
                console.log(list);
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].orderid) == 'undefined') {
                        $scope.isNull = true;
                        $scope.noData = true;
                        $scope.cnodata = '暂未收到评价，宝宝还在等…..';
                        break;
                    }
                    list[i].headimgurl = list[i].headimgurl ? list[i].headimgurl : 'images/touxiang.jpg';
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    $scope.noData = false;
                    $scope.cnodata = '';
                }
                $scope.isNull = false;
                $scope.$broadcast('scroll.refreshComplete');
            });

        };
        $scope.prams = {
            page: 2,
            limit: 5
        };
        $scope.nomore = false;
        $scope.loadMore = function() {
            try {
                $http.jsonp(url + '/api/app/rating.php?action=list&planid=' + $scope.data.planid + '&page=' + $scope.prams.page + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                    angular.forEach(data.list, function(item) {
                        if (item.null != 1) {
                            console.log(item);
                            $scope.items.push(item);
                        } else {
                            $scope.nomore = true;
                        };
                    });
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.prams.page++;
                });
            } catch (ex) {
                $scope.nomore = true;
                console.log('loadMore');
            }
        };

        $scope.dopay = function() {
            $scope.isDisabled = true;
            waiting.show($ionicLoading);
            $.ajax({
                url: url + "/api/app/wxpay.php?action=" + $scope.data.ordertype + "&access_token=" + access_token + "&callback=JSON_CALLBACK",
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    waiting.hide($ionicLoading);
                    $scope.isDisabled = false;
                },
                success: function(data) {
                    console.log(data);
                    if (data.code == "0") {
                        var alertPopup = $ionicPopup.alert({
                            title: ALERT_TITLE,
                            template: data.strmsg,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                        });
                    } else {
                        var parameters = {
                            mch_id: data.mch_id,
                            prepay_id: data.prepay_id,
                            nonce: data.nonce_str,
                            timestamp: data.timestamp,
                            sign: data.sign
                        };
                        console.log(parameters);
                        Wechat.sendPaymentRequest(parameters, function() {
                            //
                            var alertPopup = $ionicPopup.alert({
                                title: ALERT_TITLE,
                                template: '支付成功',
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                            alertPopup.then(function(res) {
                                $ionicHistory.goBack();
                            });
                        }, function(reason) {
                            //
                        });
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };
    })
    //周边列表
    .controller('AroundCtrl', function($scope, $rootScope, $ionicModal, $ionicLoading, $http, $ionicPopup, $stateParams, $state, $ionicScrollDelegate, $location, ls, sqlite) {
        var access_token = ls.get('access_token');
        var hp = '';
        $rootScope.hptext = '选择目的地';

        $rootScope.location = $rootScope.location || { name: '选择周边目的地', sid: '', www: '' };
        var location = $rootScope.location || {};
        if (location.name != '选择周边目的地') {
            hp = location.name;
        };
        $rootScope.position = {
            latitude: '',
            longitude: ''
        };

        var page = 1;
        var PAGESIZE = 20;

        var obj = {};
        obj.params = {};
        obj.params.page = page;
        obj.params.pagesize = PAGESIZE;
        $scope.items = [];
        
        $scope.$on('$ionicView.beforeEnter', function() {
            loadData();
        });
        $scope.$on('$ionicView.enter', function() {
            if ($rootScope.detailShow) {
                $rootScope.detailShow = false;
                return false;
            };
            $scope.refresh();
        });

        init_Around = function() {
            obj.params.page = page = 1;
            obj.params.hp = hp;
            $scope.isNull = false;
            $scope.isMore = false;
            $scope.moredata = false;
            $scope.items = [];
        };

        $scope.changeDesigner_level = function(obj) {
            $scope.designer_level = obj;
            $scope.change();
        };

        $scope.changeHaoping = function(obj) {
            $scope.haoping = obj;
            $scope.change();
        };

        $scope.changeRenqi = function(obj) {
            $scope.renqi = obj;
            $scope.change();
        };

        $scope.change = function() {
            obj.params.designer_level = $scope.designer_level;
            obj.params.haoping = $scope.haoping;
            obj.params.renqi = $scope.renqi;
            $scope.refresh();
        };

        $scope.refresh = function() {
            init_Around();
            loading.show($ionicLoading);
            $http.jsonp(url + '/api/app/designer.php?action=list&typeid=5&access_token=' + access_token + '&callback=JSON_CALLBACK', obj).success(function(result) {
                var list = result.list;
                console.log(list);
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].userid) == 'undefined') {
                        $scope.isNull = true;
                        $scope.isMore = false;
                        $scope.moredata = false;
                        $scope.nodata = '陛下，恕微臣无能，暂未找到与您的目的地匹配的设计师，臣当竭尽全力为你寻找！选择别的目的地也不错哟';
                        break;
                    }
                    list[i].headimgurl = list[i].headimgurl ? list[i].headimgurl : 'images/touxiang.jpg';
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    if (list.length == PAGESIZE) {
                        $scope.isMore = true;
                        $scope.moredata = true;
                        page++;
                    } else {
                        $scope.isMore = false;
                        $scope.moredata = false;
                    }
                }
                $scope.$broadcast('scroll.refreshComplete');
                loading.hide($ionicLoading);
            });
        }

        $scope.loadMore = function() {
            if (!$scope.moredata) return;
            loading.show($ionicLoading);
            obj.params.page = page;
            $http.jsonp(url + '/api/app/designer.php?action=list&typeid=5&access_token=' + access_token + '&callback=JSON_CALLBACK', obj).success(function(result) {
                var list = result.list;
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].userid) == 'undefined') {
                        break;
                    } else {
                        $scope.items.push(list[i]);
                    }
                };
                if (list.length == PAGESIZE) {
                    $scope.isMore = true;
                    $scope.moredata = true;
                    page++;
                } else {
                    $scope.isMore = false;
                    $scope.moredata = false;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                loading.hide($ionicLoading);
            });
        };

        $scope.around_details = function(id) {
            $state.go('around_details', { id: id });
        };

        function onSuccess(position) {
            $rootScope.position.latitude = position.coords.latitude;
            $rootScope.position.longitude = position.coords.longitude;
            $http.jsonp(url + "/api/app/geocoder_v2.php?location=" + position.coords.latitude + ',' + position.coords.longitude + "&callback=JSON_CALLBACK").success(function(data) {
                //alert(position.coords.latitude+','+position.coords.longitude);
                var cityname = data.result.addressComponent.city;
                if (cityname != '') {
                    $rootScope.location = { sid: data.sid, www: data.www, name: cityname };
                    ls.setObject('city', { sid: data.sid, www: data.www, name: cityname });
                    sqlite.saveData({ location: $rootScope.location });
                };
                /*if (ls.isNull(city.sid)) {
                    ls.setObject('city', {sid:data.sid, www:data.www, name:cityname});
                }*/
            });
        };

        function onError(error) {
            /*$rootScope.cityname = '选择目的地';
            $ionicPopup.alert({
                title: ALERT_TITLE,
                template: '定位失败。 code: ' + error.code + ', message: ' + error.message,
                buttons: [{
                    text: BUTTON_TEXT_CLOSE,
                    type: 'button-balanced'
                }]
            });
            $state.go('location');*/
        };

        getLocation = function() {
            if (navigator.geolocation) {
                navigator.geolocation.getCurrentPosition(onSuccess, onError, { maximumAge: 3000, timeout: 5000, enableHighAccuracy: true });
            };
        };

        if (ls.isNull(location.sid)) {
            getLocation();
        };

        //城市选择
        $scope.searchEmptyShow = false; //是否显示清除输入的图标
        $scope.showMiddle = false; //是否在屏幕中央显示选中的字母索引
        var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        $scope.indexs = [];
        //loadData();
        for (var i = 0; i < chars.length; i++) {
            $scope.indexs.push(chars.charAt(i)); //获取字母数组
        }
        $scope.name = '';
        $scope.startDot = function() { //判断清除输入框的图标是否显示
            if ($scope.name.length = 0 || $scope.name == "") {
                $scope.searchEmptyShow = false;
            } else {
                $scope.searchEmptyShow = true;
            }
        };
        $scope.searchEmpty = function() { //点击清除输入框的图标的点击事件
            $scope.searchEmptyShow = false;
            $scope.name = "";
        };
        $scope.mTouch = function(c) {
            $scope.showMiddle = true;
            $scope.hint = c;
            $location.hash("city_" + $scope.hint);
            $ionicScrollDelegate.anchorScroll(true); //方式2
        };
        $scope.mRelease = function() {
            $timeout(function() {
                $scope.showMiddle = false;
            }, 300);
        };

        function loadData() { //从本地的一个包含全国各城市的json文件中加载数据
            $http.get("data/city.json").success(function(data) {
                $scope.cityDatas = data;
                $ionicLoading.hide();
            });
        }

        $scope.changeCity = function(obj) {
            $rootScope.location = { sid: obj.regionid, name: obj.name };
            ls.setObject('city', { sid: obj.regionid, name: obj.name });
            $state.go("around", {}, { reload: true })
                //getlist();
            $scope.cityModal.hide();
        };

        $ionicModal.fromTemplateUrl('templates/city_modal.html', function($ionicModal) {
            $scope.cityModal = $ionicModal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });
        $scope.openModal = function() {
            $scope.cityModal.show();
        };
        $scope.closeModal = function() {
            $scope.cityModal.hide();
        };
        $scope.$on('$destroy', function() {
            $scope.cityModal.remove();
        });
    })
    //设计师详情(周边)
    .controller('AroundDetailsCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicActionSheet, $ionicSlideBoxDelegate, $http, $state, $stateParams, ls) {
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var access_token = ls.get('access_token');
        var member = ls.getObject('member');
        $rootScope.detailShow = true;
        waiting.show($ionicLoading);
        $http.jsonp(url + '/api/app/designer.php?action=show&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
            waiting.hide($ionicLoading);
            data.bgimage = data.bgimage ? data.bgimage : 'images/des_bg.jpg'; //背景图片默认判别
            $scope.data = data;
            $scope.tags = data.tags.split(',');
            $scope.familiar_places = data.familiar_places.split(',');
            $ionicSlideBoxDelegate.update();

        });
        $scope.plans = [];
        $scope.items = [];
        $scope.noData = true;
        $scope.isNull = false;
        $http.jsonp(url + '/api/app/plans.php?action=designer&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
            waiting.hide($ionicLoading);
            var list = data.list;
            console.log(list);
            for (var i = 0; i < list.length; i++) {
                if (typeof(list[i].title) == 'undefined') {
                    $scope.isNull = true;
                    $scope.nodata = '小主，您还没有需要查看的信息哦';
                    break;
                }
            }
            if (!$scope.isNull) {
                $scope.plans = list;
                $scope.nodata = '';
            }
            $scope.isNull = false;
            $ionicSlideBoxDelegate.update();
        });
        setTimeout(getComments(), 5000);
        $scope.doRefresh = function() {
            getComments();
        };

        function getComments() {
            $http.jsonp(url + '/api/app/rating.php?action=list&userid=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                var list = data.list;
                console.log(list);
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].orderid) == 'undefined') {
                        $scope.isNull = true;
                        $scope.noData = true;
                        $scope.cnodata = '暂未收到评价，宝宝还在等…..';
                        break;
                    }
                    list[i].headimgurl = list[i].headimgurl ? list[i].headimgurl : 'images/touxiang.jpg';
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    $scope.noData = false;
                    $scope.cnodata = '';
                }
                $scope.isNull = false;
                $scope.$broadcast('scroll.refreshComplete');
            });

        };
        $scope.prams = {
            page: 2,
            limit: 5
        };
        $scope.nomore = false;
        $scope.loadMore = function() {
            try {
                $http.jsonp(url + '/api/app/rating.php?action=list&userid=' + $scope.data.userid + '&page=' + $scope.prams.page + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                    angular.forEach(data.list, function(item) {
                        if (item.null != 1) {
                            console.log(item);
                            $scope.items.push(item);
                        } else {
                            $scope.nomore = true;
                        };
                    });
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    $scope.prams.page++;
                });
            } catch (ex) {
                $scope.nomore = true;
                console.log('loadMore');
            }
        };
        $scope.showShareChoices = function() {
            var hideSheet = $ionicActionSheet.show({
                buttons: [{
                    text: '分享给 <b>好友</b>'
                }, {
                    text: '分享到 <b>朋友圈</b>'
                }],
                titleText: '微信分享',
                cancelText: '取 消',
                cancel: function() {
                    // add cancel code..
                },
                buttonClicked: function(index) {
                    WechatShare(index);
                    return true;
                }
            });
        };
        WechatShare = function(index) {
            Wechat.share({
                message: {
                    title: "我是旅行达人，给你完美旅行线路，帮你轻松挣钱！—自由人旅行",
                    description: "个性化旅行服务平台，最专业的旅行设计师为您量身定制专属行程。",
                    thumb: "www/images/share_thumb.jpg",
                    media: {
                        type: Wechat.Type.LINK,
                        webpageUrl: url + "/download/"
                    }
                },
                scene: index == 0 ? Wechat.Scene.SESSION : Wechat.Scene.TIMELINE
            }, function() {
                //
            }, function(reason) {
                //
            });
        };
        $scope.pay = function(obj) {
            var data = {
                planid: obj.planid,
                ordertype: 'ordercopy',
                userid: obj.userid,
                nickname: obj.nickname,
                title: obj.title,
                headimgurl: obj.headimgurl,
                price: obj.price,
                keywords: obj.keywords
            };
            $rootScope.pay = data;
            $state.go('pay');
        };
        $scope.comment_done = function(id) {
            $state.go('comment_done', { id: id });
        };
        $scope.usermessages = function(userid, nickname, headimgurl) {
            $rootScope.toUser = {
                _id: userid,
                pic: headimgurl,
                username: nickname
            }
            if (typeof(member.headimgurl) == 'undefined') {
                member.userid = '10008';
                member.headimgurl = 'images/touxiang.jpg';
                member.nickname = 'cheng';
            };
            $rootScope.user = {
                _id: member.userid,
                pic: member.headimgurl,
                username: member.nickname
            }
            console.log($rootScope.toUser);
            console.log($rootScope.user);
            if (userid == member.userid) {
                window.plugins.toast.showShortBottom('不可以给自己发送消息喔！', function() {}, function(error) {});
            } else {
                $state.go('usermessages');
            }
        };
        $scope.around_choose = function(id) {
            $state.go('around_choose', { id: id });
        };
        $scope.random = function() {
            return Math.ceil(Math.random() * 4);
        };
    })
    //行程需求(周边)
    .controller('AroundOrderCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $http, $stateParams, $state, $ionicHistory, ls, sqlite, ionicDatePicker, $filter, $ionicScrollDelegate, $timeout, $location) {
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var access_token = ls.get('access_token');
        //sqlite.loadData();
        $rootScope.location = $rootScope.location || { name: '选择周边目的地', sid: '', www: '' };

        var location = $rootScope.location || {};
        $scope.current = {
            name: location.name,
            sid: location.sid,
            www: location.www
        };
        $scope.city = '';
        $scope.$on('$ionicView.enter', function() {
            loadData();
        });
        waiting.show($ionicLoading);
        $http.jsonp(url + '/api/app/designer.php?action=show&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
            waiting.hide($ionicLoading);
            $ionicSlideBoxDelegate.update();
            //data.cfd = '请选择出发地';
            //data.mdd = [location.name];
            data.days = 1;
            data.adults = 1;
            data.kids = 0;
            data.budget = 0;
            data.headimgurl = data.headimgurl ? data.headimgurl : 'images/touxiang.jpg';
            $scope.data = data;
            $scope.data.keywords = '';
            $scope.familiar_places = data.familiar_places.split(',');
            console.log($scope.data);
        });
        //城市选择
        $scope.searchEmptyShow = false; //是否显示清除输入的图标
        $scope.showMiddle = false; //是否在屏幕中央显示选中的字母索引
        var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        $scope.indexs = [];
        for (var i = 0; i < chars.length; i++) {
            $scope.indexs.push(chars.charAt(i)); //获取字母数组
        }
        $scope.name = '';
        $scope.startDot = function() { //判断清除输入框的图标是否显示
            if ($scope.name.length = 0 || $scope.name == "") {
                $scope.searchEmptyShow = false;
            } else {
                $scope.searchEmptyShow = true;
            }
        };
        $scope.searchEmpty = function() { //点击清除输入框的图标的点击事件
            $scope.searchEmptyShow = false;
            $scope.name = "";
        };
        $scope.mTouch = function(c) {
            $scope.showMiddle = true;
            $scope.hint = c;
            $location.hash("city_" + $scope.hint);
            $ionicScrollDelegate.anchorScroll(true); //方式2
        };
        $scope.mRelease = function() {
            $timeout(function() {
                $scope.showMiddle = false;
            }, 300);
        };

        function loadData() { //从本地的一个包含全国各城市的json文件中加载数据
            $http.get("data/city.json").success(function(data) {
                $scope.cityDatas = data;
                $ionicLoading.hide();
            });
        }
        $scope.changeCity = function(obj) {
            if ($scope.field == 'cfd') {
                $scope.data.cfd = obj.name;
            } else {
                $scope.data.mdd = obj.name;
            };
            $scope.cityModal.hide();
        };

        $ionicModal.fromTemplateUrl('templates/city_modal.html', function($ionicModal) {
            $scope.cityModal = $ionicModal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });
        $scope.openModal = function(field) {
            $scope.field = field;
            $scope.cityModal.show();
        };
        $scope.closeModal = function() {
            $scope.cityModal.hide();
        };
        $scope.$on('$destroy', function() {
            $scope.cityModal.remove();
        });
        //主题选择
        $ionicModal.fromTemplateUrl('templates/keywords_modal.html', function($ionicModal) {
            $scope.keywordsModal = $ionicModal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });

        function getKeywords() {
            $http.get("data/keywords.json").success(function(result) {
                $scope.keywords = new Array();
                for (var i = 0; i < result.length; i++) {
                    var str = $scope.data.keywords || '';
                    $scope.keywords[i] = new Array();
                    $scope.keywords[i]['text'] = result[i];
                    $scope.keywords[i]['checked'] = str.indexOf(result[i]) == -1 ? false : true;
                };
            });
        }
        $scope.openKeywordsModal = function() {
            getKeywords();
            $scope.keywordsModal.show();
        };
        $scope.closeKeywordsModal = function() {
            $scope.keywordsModal.hide();
        };
        $scope.$on('$destroy', function() {
            $scope.keywordsModal.remove();
        });
        $scope.keywordsChange = function(index) {
            var k = $scope.keywords[index];
            var str = $scope.data.keywords;
            var keywords = $scope.data.keywords.split(',');
            if (k.checked) {
                if (keywords.length == 4) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: '旅游主题最多选择4个。',
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    removeItem(k, str, keywords);
                    $scope.keywords[index].checked = false;
                } else {
                    addItem(k, str, keywords);
                };
            } else {
                removeItem(k, str, keywords);
            };
        };

        function addItem(k, str, keywords) {
            if (str.indexOf(k.text) == -1) {
                for (var i in keywords) {
                    if (keywords[i].length == 0) keywords.splice(i, 1);
                }
                keywords.push(k.text);
                $scope.data.keywords = keywords.join(',');
            };
        };

        function removeItem(k, str, keywords) {
            if (str.indexOf(k.text) > -1) {
                for (var i in keywords) {
                    if (keywords[i] == k.text) {
                        keywords.splice(i, 1);
                        break;
                    };
                    if (keywords[i].length == 0) keywords.splice(i, 1);
                }
            };
            $scope.data.keywords = keywords.join(',');
        };

        $scope.add = function() {
            $scope.data.designerid = $scope.data.userid;
            $scope.data.typeid = 6;
            $scope.data.title = $rootScope.location.name + "周边游玩";
            $scope.data.mdd = $rootScope.location.name;
            //$scope.data.mdd = $scope.data['mdd'].join(",");

            $scope.isDisabled = true;
            waiting.show($ionicLoading);
            $.ajax({
                url: url + '/api/app/wxpay.php?access_token=' + access_token + '&callback=JSON_CALLBACK',
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    waiting.hide($ionicLoading);
                    $scope.isDisabled = false;
                },
                success: function(data) {
                    console.log(data);
                    if (data.code == "0") {
                        var alertPopup = $ionicPopup.alert({
                            title: ALERT_TITLE,
                            template: data.strmsg,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                        });
                    } else {
                        var parameters = {
                            mch_id: data.mch_id,
                            prepay_id: data.prepay_id,
                            nonce: data.nonce_str,
                            timestamp: data.timestamp,
                            sign: data.sign
                        };
                        console.log(parameters);
                        Wechat.sendPaymentRequest(parameters, function() {
                            //
                            var alertPopup = $ionicPopup.alert({
                                title: ALERT_TITLE,
                                template: '支付成功',
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                            alertPopup.then(function(res) {
                                $ionicHistory.goBack(-3);
                            });
                        }, function(reason) {
                            //
                        });
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

        var ipObj1 = {
            callback: function(val) {
                $scope.data.starttime = $filter('date')(new Date(val), 'yyyy-MM-dd');
                $scope.starttime = val;
            },
            disabledDates: [

            ],
            titleLabel: '',
            from: new Date(),
            to: new Date().setYear(new Date().getFullYear() + 1),
            inputDate: new Date(),
            mondayFirst: false,
            //disableWeekdays: [0],
            closeOnSelect: false,
            dateFormat: 'yyyy-MM-dd',
            showTodayButton: true,
            templateType: 'modal'
        };
        var ipObj2 = {
            callback: function(val) {
                $scope.data.endtime = $filter('date')(new Date(val), 'yyyy-MM-dd');
                $scope.endtime = val;
                var date = $scope.endtime - $scope.starttime;
                var days = Math.floor(date / (24 * 3600 * 1000));
                $scope.data.days = days;
            },
            disabledDates: [

            ],
            titleLabel: '',
            from: new Date(),
            to: new Date().setYear(new Date().getFullYear() + 1),
            inputDate: new Date(),
            mondayFirst: false,
            //disableWeekdays: [0],
            closeOnSelect: false,
            dateFormat: 'yyyy-MM-dd',
            showTodayButton: true,
            templateType: 'modal'
        };

        $scope.openDatePicker = function(obj) {
            if (obj == 'starttime') {
                ionicDatePicker.openDatePicker(ipObj1);
                $scope.getprice();
            };
            if (obj == 'endtime') {
                ionicDatePicker.openDatePicker(ipObj2);
                $scope.getprice();
            };
        };
        $scope.getdays = function() {
            var date1 = $scope.data.starttime; //开始时间
            var date2 = $scope.data.endtime; //结束时间
            //console.log(date1);
            var date3 = date2.getTime() - date1.getTime(); //时间差的毫秒数
            var days = Math.floor(date3 / (24 * 3600 * 1000)); //计算出相差天数
            $scope.data.days = days;
            //console.log(days);
        };
        //动态调整价格
        $scope.getprice = function() {
            var days=$scope.data.days;
            var price=0;
            if (days>=1&&days<=2) {
                price=20;
            }else if (days>=3&&days<=4) {
                price=30;
            }else if (days>=5&&days<=6) {
                price=40;
            }else{
                price=50
            };
            $scope.data.price = price;
            //console.log(price);
        };
        $scope.isuntime = function() {
            var isChecked = $scope.data.isuntime;
            if (isChecked) {
                $('.cxts').show();
                $('.gjl_chufa_time').hide();
            } else {
                $('.cxts').hide();
                $('.gjl_chufa_time').show();
            }
        };
    })
    //消息列表
    .controller('NewsCtrl', function($scope, $rootScope, $ionicLoading, $http, $ionicPopup, $ionicActionSheet, $state, ls) {
        var access_token = ls.get('access_token');
        getlist();
        $scope.doRefresh = function() {
            getlist();
        };

        function getlist() {
            $scope.noData = true;
            $scope.isNull = false;
            $scope.items = [];

            //loading.show($ionicLoading);
            $http.jsonp(url + '/api/app/notification.php?action=list&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                var list = data;
                if (list == null) {
                    $scope.isNull = true;
                    $scope.noData = true;
                    $scope.nodata = '小主，您还没有需要查看的信息哦';
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    $scope.noData = false;
                    $scope.nodata = '';
                }
                $scope.$broadcast('scroll.refreshComplete');
                loading.hide($ionicLoading);
            });
        };

        $scope.news_details = function(id) {
            $state.go('news_details', { id: id });
        };


    })
    //消息详情
    .controller('NewsDetailsCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $http, $state, $stateParams, ls) {
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var access_token = ls.get('access_token');
        //waiting.show($ionicLoading);
        $http.jsonp(url + '/api/app/notification.php?action=show&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
            waiting.hide($ionicLoading);
            $scope.data = data;
            $ionicSlideBoxDelegate.update();

        });
    })
    //文章详情
    .controller('ArticleDetailsCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $http, $state, $stateParams, ls) {
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var access_token = ls.get('access_token');
        //waiting.show($ionicLoading);
        $http.jsonp(url + '/api/app/article.php?action=show&id=' + id + '&callback=JSON_CALLBACK').success(function(data) {
            waiting.hide($ionicLoading);
            $scope.data = data;
        });
    })
    //活动列表
    .controller('ActivityCtrl', function($scope, $rootScope, $ionicLoading, $http, $ionicPopup, $ionicActionSheet, $state, ls) {
        var access_token = ls.get('access_token');
        getlist();
        $scope.doRefresh = function() {
            getlist();
        };

        function getlist() {
            $scope.noData = true;
            $scope.isNull = false;
            $scope.items = [];

            //loading.show($ionicLoading);
            $http.jsonp(url + '/api/app/announcement.php?action=list&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                var list = data;
                if (list == null) {
                    $scope.isNull = true;
                    $scope.noData = true;
                    $scope.nodata = '小主，您还没有需要查看的信息哦';
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    $scope.noData = false;
                    $scope.nodata = '';
                }
                $scope.$broadcast('scroll.refreshComplete');
                loading.hide($ionicLoading);
            });
        };

        $scope.activity_details = function(id) {
            $state.go('activity_details', { id: id });
        };


    })
    //活动详情
    .controller('ActivityDetailsCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $http, $state, $stateParams, ls) {
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        var access_token = ls.get('access_token');
        //waiting.show($ionicLoading);
        $http.jsonp(url + '/api/app/announcement.php?action=show&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
            waiting.hide($ionicLoading);
            $scope.data = data;
            $ionicSlideBoxDelegate.update();

        });
    })
    //城市选择
    .controller('LocationCtrl', function($window, $scope, $location, $ionicScrollDelegate, $rootScope, $http, $ionicSlideBoxDelegate, $ionicPopup, $ionicLoading, $state, $ionicHistory, $timeout, ls, sqlite) {
        //sqlite.loadData();
        var access_token = ls.get('access_token');
        var location = $rootScope.location || {};
        $scope.city = '';
        $rootScope.location = $rootScope.location || { name: '选择周边目的地', sid: '', www: '' };

        $rootScope.position = {
            latitude: '',
            longitude: ''
        };
        $scope.$on('$ionicView.enter', function() {
            loadData();
        });
        $scope.doRefresh = function() {};

        function onSuccess(position) {
            $rootScope.position.latitude = position.coords.latitude;
            $rootScope.position.longitude = position.coords.longitude;
            //console.log($rootScope.position);
            $http.jsonp(url + "/api/app/geocoder_v2.php?location=" + position.coords.latitude + ',' + position.coords.longitude + "&callback=JSON_CALLBACK").success(function(data) {
                var cityname = data.result.addressComponent.city;
                if (cityname != '') {
                    $rootScope.location = { sid: data.sid, www: data.www, name: cityname };
                    ls.setObject('city', { sid: data.sid, www: data.www, name: cityname });
                };
            });
        };

        function onError(error) {
            /*$rootScope.cityname = '选择目的地';
            $ionicPopup.alert({
                title: ALERT_TITLE,
                template: '定位失败。 code: ' + error.code + ', message: ' + error.message,
                buttons: [{
                    text: BUTTON_TEXT_CLOSE,
                    type: 'button-balanced'
                }]
            });*/

        };
        getLocation = function() {
            navigator.geolocation.getCurrentPosition(onSuccess, onError, { maximumAge: 3000, timeout: 5000, enableHighAccuracy: true });
        };
        $scope.customLocation = function(sid, cityname) {
            $rootScope.location = { sid: sid, name: cityname };
            ls.setObject('city', { sid: sid, name: cityname });
            $ionicHistory.goBack(); //返回上一页
        };
        if (ls.isNull(location.sid)) {
            getLocation();
        };

        $scope.searchEmptyShow = false; //是否显示清除输入的图标
        $scope.showMiddle = false; //是否在屏幕中央显示选中的字母索引
        //$scope.hIndex=($(window).height()-44-4)/26;//右边侧边栏每个字母的高度，是屏幕高度减去标题栏的44，减去页面样式中的margin-top:2px，margin-bottom:2px,再除以26，这样以保证在各个手机屏幕上的字母的距离的均等性
        var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        $scope.indexs = [];
        for (var i = 0; i < chars.length; i++) {
            $scope.indexs.push(chars.charAt(i)); //获取字母数组
        }
        $scope.startDot = function() { //判断清除输入框的图标是否显示
            if ($scope.name.length = 0 || $scope.name == "") {
                $scope.searchEmptyShow = false;
            } else {
                $scope.searchEmptyShow = true;
            }
        };
        $scope.searchEmpty = function() { //点击清除输入框的图标的点击事件
            $scope.searchEmptyShow = false;
            $scope.name = "";
        };
        $scope.mTouch = function(c) {
            console.log(c);
            $timeout(function() {
                $scope.showMiddle = true;
            }, 300);
            $scope.hint = c;
            console.log(c);
            $location.hash("city_" + $scope.hint);

            $ionicScrollDelegate.anchorScroll(true); //方式2

        };

        $scope.mRelease = function() {
            window.plugins.toast.showShortBottom('0', function() {}, function(error) {});
            $timeout(function() {
                $scope.showMiddle = false;
            }, 300);
        };

        function loadData() { //从本地的一个包含全国各城市的json文件中加载数据
            $ionicLoading.show();
            $http.get("data/city.json").success(function(data) {
                $scope.cityDatas = data;
                $ionicLoading.hide();
            });
        }
    })
    //手机验证
    .controller('PhoneVerificationCtrl', function($window, $scope, $rootScope, $ionicPopup, $http, $ionicLoading, $state, $interval, $ionicHistory, ls, sqlite) {
        var access_token = ls.get('access_token');
        $scope.member = ls.getObject('member');
        $scope.isDisabled = false;
        $scope.sendcodeDisabled = false;
        //$rootScope.phoneVerified = true;

        $scope.data = {
            phone: '',
            verifycode: '',
        };

        $scope.bs = '发送验证码';

        $scope.sendcode = function() {
            var regMobile = /^13[0-9]{9}$|14[0-9]{9}$|15[0-9]{9}$|17[0-9]{9}$|18[0-9]{9}$/;

            var p = $scope.data.phone;
            if (p == "") {
                $ionicPopup.alert({
                    title: ALERT_TITLE,
                    template: '请输入手机号。',
                    buttons: [{
                        text: BUTTON_TEXT_CLOSE,
                        type: 'button-balanced'
                    }]
                });
            } else if (!regMobile.test(p)) {
                $ionicPopup.alert({
                    title: ALERT_TITLE,
                    template: '手机号码格式不对。',
                    buttons: [{
                        text: BUTTON_TEXT_CLOSE,
                        type: 'button-balanced'
                    }]
                });
            } else {
                $scope.count = 60;
                var time = $interval(function() {
                    $scope.count--;
                    $scope.sendcodeDisabled = true;
                    $scope.bs = '重发(' + $scope.count + ')';
                    if ($scope.count == 0) {
                        $interval.cancel(time);
                        $scope.sendcodeDisabled = false;
                        $scope.bs = '重发';
                    }
                }, 1000);

                $http.jsonp(url + '/api/app/sendcode.php?phone=' + p + '&callback=JSON_CALLBACK').success(function(data) {
                    if (data.status == "success") {
                        //
                    } else {
                        var info = data.info;
                        $ionicPopup.alert({
                            title: ALERT_TITLE,
                            template: info,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-assertive' }]
                        });
                    }
                });
            }
        };

        $scope.dosubmit = function() {
            $scope.isDisabled = true;
            waiting.show($ionicLoading);
            $.ajax({
                url: url + "/api/app/user.php?action=phoneverified&access_token=" + access_token,
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    $scope.isDisabled = false;
                    waiting.hide($ionicLoading);
                },
                success: function(data) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: data.strmsg,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });

                    if (data.code == "1") {
                        $scope.member.phone = $scope.data.phone;
                        ls.setObject('member', $scope.member);
                        sqlite.saveData({ member: $scope.member });
                        alertPopup.then(function(res) {
                            $scope.goback();
                        });
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

        $scope.goback = function() {
            $ionicHistory.goBack();
        };
    })
    //用户反馈
    .controller('MycenterFeedbackCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $http, $state, $ionicActionSheet, sqlite, $stateParams, ls) {
        var access_token = ls.get('access_token');

        $scope.data = {
            text: "",
            phone: ""
        };

        $scope.dosubmit = function() {
            waiting.show($ionicLoading);
            $.ajax({
                url: url + "/api/app/feedback.php?access_token=" + access_token,
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    waiting.hide($ionicLoading);
                },
                success: function(data) {
                    if (data.code == "1") {
                        $scope.data = {
                            text: "",
                            phone: ""
                        };
                    }
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: data.strmsg,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

    })
    //选择省份或城市
    .controller('LocationProvinceCtrl', function($window, $scope, $rootScope, $http, $ionicSlideBoxDelegate, $ionicPopup, $ionicLoading, $stateParams, $state, $ionicHistory, $timeout, ls, sqlite) {
        $scope.groups = [];
        $scope.isHotShow = true;
        $scope.isProvinceShow = false;
        $scope.isHotActive = 'active';
        $scope.isProvinceActive = '';
        var page = typeof($stateParams.page) == 'undefined' ? '' : $stateParams.page;
        var backcount = typeof($stateParams.backcount) == 'undefined' ? '' : $stateParams.backcount;
        $rootScope.HP = typeof($rootScope.HP) == 'undefined' ? '' : $rootScope.HP;
        $rootScope.FP = typeof($rootScope.FP) == 'undefined' ? '' : $rootScope.FP;

        $http.get("data/hot.json").success(function(result) {
            $scope.hot = new Array();
            if (result['area']) {
                $scope.hot['area'] = new Array();
                for (var j = 0; j < result['area'].length; j++) {
                    $scope.hot['area'][j] = result['area'][j];
                    //$scope.hot[i]['area'][j]['regionid'] = result['area'][j]['regionid'];
                }
                var data = $scope.hot.area;
                var result1 = [];
                for (var i = 0, len = data.length; i < len; i += 2) {
                    result1.push(data.slice(i, i + 2));
                }
                $scope.hot['area'] = result1;
            };
            if (result['mdd']) {
                $scope.hot['mdd'] = new Array();
                for (var j = 0; j < result['mdd'].length; j++) {
                    $scope.hot['mdd'][j] = result['mdd'][j];
                }
                var data1 = $scope.hot.mdd;
                var result1 = [];
                for (var i = 0, len = data1.length; i < len; i += 2) {
                    result1.push(data1.slice(i, i + 2));
                }
                $scope.hot['mdd'] = result1;
            };
            //console.log(result);
        });

        $scope.toggleGroup = function(group) {
            group.show = !group.show;
        };
        $scope.isGroupShown = function(group) {
            return group.show;
        };
        $scope.show_hot = function() {
            $scope.isHotShow = true;
            $scope.isProvinceShow = false;
            $scope.isHotActive = 'active';
            $scope.isProvinceActive = '';
        };
        $scope.show_province = function() {
            $scope.isHotShow = false;
            $scope.isProvinceShow = true;
            $scope.isHotActive = '';
            $scope.isProvinceActive = 'active';
            //waiting.show($ionicLoading);
            $http.get("data/area.json").success(function(result) {
                //waiting.hide($ionicLoading);
                $scope.area = new Array();
                //console.log(result);
                for (var i = 0; i < result.length; i++) {
                    $scope.area[i] = new Array();
                    $scope.area[i]['name'] = result[i]['name'];
                    //$scope.area[i]['regionid'] = result[i]['regionid'];
                    if (result[i]['children']) {
                        $scope.area[i]['children'] = new Array();
                        for (var j = 0; j < result[i]['children'].length; j++) {
                            $scope.area[i]['children'][j] = new Array();
                            $scope.area[i]['children'][j]['name'] = result[i]['children'][j]['name'];
                            //$scope.area[i]['children'][j]['regionid'] = result[i]['children'][j]['regionid'];
                        }
                    };
                };
            });
        };

        $scope.add_location = function(name) {
            if (page == "mycenter_edit") {
                var str = $rootScope.FP;
                if (str.indexOf(name) > -1) {
                    $rootScope.FP = str.replace(name + ',', ''); //存在则删除
                    var str = $rootScope.FP;
                    if (str.indexOf(name) > -1) {
                        $rootScope.FP = str.replace(name, '');
                        $rootScope.FP = $rootScope.FP.replace(/,$/g, "");
                    }
                } else {
                    var obj = $rootScope.FP.split(",");
                    if (obj.length >= $rootScope.FPLN) {
                        window.plugins.toast.showShortBottom('最多可以选择' + $rootScope.FPLN + '个熟悉目的地喔！', function() {}, function(error) {});
                    } else {
                        if ($rootScope.FP == '') {
                            $rootScope.FP = $rootScope.FP + name + ',';
                        } else {
                            $rootScope.FP = $rootScope.FP + ',' + name + ',';
                        }
                        $rootScope.FP = $rootScope.FP.replace(/,$/g, "");
                    }
                }
            } else if (page == "trip") {
                var str = $rootScope.HP;
                console.log(str);
                if (str.indexOf(name) > -1) {
                    $rootScope.HP = str.replace(name + ',', ''); //存在则删除
                    var str = $rootScope.HP;
                    if (str.indexOf(name) > -1) {
                        $rootScope.HP = str.replace(name, '');
                        $rootScope.HP = $rootScope.HP.replace(/,$/g, "");
                    }
                } else {
                    var obj = $rootScope.HP.split(",");
                    if (obj.length >= TLN) {
                        window.plugins.toast.showShortBottom('最多可以选择' + TLN + '个目的地喔！', function() {}, function(error) {});
                    } else {
                        if ($rootScope.HP == '') {
                            $rootScope.HP = $rootScope.HP + name + ',';
                        } else {
                            $rootScope.HP = $rootScope.HP + ',' + name + ',';
                        }
                        $rootScope.HP = $rootScope.HP.replace(/,$/g, "");
                    }
                }
            };
        };
        $scope.is_have_location = function(name) {
            if (page == "mycenter_edit") {
                var str = $rootScope.FP;
                if (str.indexOf(name) > -1) {
                    return true;
                } else {
                    return false;
                }
            } else if (page == "trip") {
                var str = $rootScope.HP;
                if (str.indexOf(name) > -1) {
                    return true;
                } else {
                    return false;
                }
            }
        };
        $scope.location_done = function() {
            var backCount = -1;
            if (page == "trip") {
                if (backcount != '-1') {
                    backCount = -3;
                    console.log(backCount);
                }
            };
            $ionicHistory.goBack(backCount); //返回
        };
    })
    //发布需求
    .controller('DemandCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $ionicSlideBoxDelegate, $http, $stateParams, $state, $ionicHistory, $ionicScrollDelegate, $location, ls, sqlite, ionicDatePicker, $filter) {
        var access_token = ls.get('access_token');
        var HP = typeof($rootScope.HP) == 'undefined' ? '' : $rootScope.HP;

        $scope.data = {
            designerid: 0,
            typeid: 8,
            title: "发布需求",
            bcxq: '',
            tjms: false,
            tjyl: false,
            starttime: '',
            endtime: '',
            days: 1,
            isuntime: true,
            remark: '',
            budget: 0,
            linkman: '',
            linktel: '',
            price: 20,
            mdd: HP || '',
            keywords: ''
        };

        $scope.$on('$ionicView.beforeEnter', function() {
            HP = typeof($rootScope.HP) == 'undefined' ? '' : $rootScope.HP;
            $scope.data.mdd = HP || '';
            console.log($scope.data.mdd);
            console.log(123);
        });
        $scope.$on('$ionicView.enter', function() {
            loadData();
        });
        $scope.searchEmptyShow = false; //是否显示清除输入的图标
        $scope.showMiddle = false; //是否在屏幕中央显示选中的字母索引
        var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
        $scope.indexs = [];
        
        for (var i = 0; i < chars.length; i++) {
            $scope.indexs.push(chars.charAt(i)); //获取字母数组
        }
        $scope.name = '';
        $scope.startDot = function() { //判断清除输入框的图标是否显示
            if ($scope.name.length = 0 || $scope.name == "") {
                $scope.searchEmptyShow = false;
            } else {
                $scope.searchEmptyShow = true;
            }
        };
        $scope.searchEmpty = function() { //点击清除输入框的图标的点击事件
            $scope.searchEmptyShow = false;
            $scope.name = "";
        };
        $scope.mTouch = function(c) {
            $scope.showMiddle = true;
            $scope.hint = c;
            $location.hash("city_" + $scope.hint);
            $ionicScrollDelegate.anchorScroll(true); //方式2
        };
        $scope.mRelease = function() {
            $timeout(function() {
                $scope.showMiddle = false;
            }, 300);
        };

        function loadData() { //从本地的一个包含全国各城市的json文件中加载数据
            $http.get("data/city.json").success(function(data) {
                $scope.cityDatas = data;
                $ionicLoading.hide();
            });
        }

        $scope.changeCity = function(obj) {
            if ($scope.field == 'cfd') {
                $scope.data.cfd = obj.name;
            } else {
                $scope.data.mdd = obj.name;
            };

            $scope.cityModal.hide();
        };
        $ionicModal.fromTemplateUrl('templates/city_modal.html', function($ionicModal) {
            $scope.cityModal = $ionicModal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });
        $scope.openModal = function(field) {
            $scope.field = field;
            $scope.cityModal.show();
        };
        $scope.closeModal = function() {
            $scope.cityModal.hide();
        };
        $scope.$on('$destroy', function() {
            $scope.cityModal.remove();
        });
        //主题选择
        $ionicModal.fromTemplateUrl('templates/keywords_modal.html', function($ionicModal) {
            $scope.keywordsModal = $ionicModal;
        }, {
            scope: $scope,
            animation: 'slide-in-up'
        });

        function getKeywords() {
            $http.get("data/keywords.json").success(function(result) {
                $scope.keywords = new Array();
                for (var i = 0; i < result.length; i++) {
                    var str = $scope.data.keywords || '';
                    $scope.keywords[i] = new Array();
                    $scope.keywords[i]['text'] = result[i];
                    $scope.keywords[i]['checked'] = str.indexOf(result[i]) == -1 ? false : true;
                };
            });
        }
        $scope.openKeywordsModal = function() {
            getKeywords();
            $scope.keywordsModal.show();
        };
        $scope.closeKeywordsModal = function() {
            $scope.keywordsModal.hide();
        };
        $scope.$on('$destroy', function() {
            $scope.keywordsModal.remove();
        });
        $scope.keywordsChange = function(index) {
            var k = $scope.keywords[index];
            var str = $scope.data.keywords;
            var keywords = $scope.data.keywords.split(',');
            if (k.checked) {
                if (keywords.length == 4) {
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: '旅游主题最多选择4个。',
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                    removeItem(k, str, keywords);
                    $scope.keywords[index].checked = false;
                } else {
                    addItem(k, str, keywords);
                };
            } else {
                removeItem(k, str, keywords);
            };
        };

        function addItem(k, str, keywords) {
            if (str.indexOf(k.text) == -1) {
                for (var i in keywords) {
                    if (keywords[i].length == 0) keywords.splice(i, 1);
                }
                keywords.push(k.text);
                $scope.data.keywords = keywords.join(',');
            };
        };

        function removeItem(k, str, keywords) {
            if (str.indexOf(k.text) > -1) {
                for (var i in keywords) {
                    if (keywords[i] == k.text) {
                        keywords.splice(i, 1);
                        break;
                    };
                    if (keywords[i].length == 0) keywords.splice(i, 1);
                }
            };
            $scope.data.keywords = keywords.join(',');
        };
        $scope.add = function() {
            $scope.isDisabled = true;
            $scope.data.adults = $scope.data.adults ? $scope.data.adults : 1,
                $scope.data.kids = $scope.data.kids ? $scope.data.kids : 0,
                console.log($scope.data);
            waiting.show($ionicLoading);
            $.ajax({
                url: url + '/api/app/wxpay.php?access_token=' + access_token + '&callback=JSON_CALLBACK',
                type: 'post',
                timeout: HTTP_TIMEOUT,
                async: true,
                data: $scope.data,
                dataType: 'json',
                complete: function(XMLHttpRequest, status) {
                    waiting.hide($ionicLoading);
                    $scope.isDisabled = false;
                },
                success: function(data) {
                    console.log(data);
                    if (data.code == "0") {
                        var alertPopup = $ionicPopup.alert({
                            title: ALERT_TITLE,
                            template: data.strmsg,
                            buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                        });
                    } else {
                        var parameters = {
                            mch_id: data.mch_id,
                            prepay_id: data.prepay_id,
                            nonce: data.nonce_str,
                            timestamp: data.timestamp,
                            sign: data.sign
                        };
                        console.log(parameters);
                        Wechat.sendPaymentRequest(parameters, function() {
                            //
                            var alertPopup = $ionicPopup.alert({
                                title: ALERT_TITLE,
                                template: '支付成功',
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                            alertPopup.then(function(res) {
                                $ionicHistory.goBack();
                            });
                        }, function(reason) {
                            //
                        });
                    }
                },
                error: function(XMLHttpRequest, textStatus, errorThrown) {
                    var text;
                    text = textStatus;
                    if (textStatus == 'timeout') {
                        text = TEXT_STATUS_TIMEOUT;
                    };
                    if (textStatus == 'error') {
                        text = TEXT_STATUS_ERROR;
                    };
                    var alertPopup = $ionicPopup.alert({
                        title: ALERT_TITLE,
                        template: text,
                        buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                    });
                }
            });
        };

        var ipObj1 = {
            callback: function(val) {
                $scope.data.starttime = $filter('date')(new Date(val), 'yyyy-MM-dd');
                $scope.starttime = val;
            },
            disabledDates: [

            ],
            titleLabel: '',
            from: new Date(),
            to: new Date().setYear(new Date().getFullYear() + 1),
            inputDate: new Date(),
            mondayFirst: false,
            //disableWeekdays: [0],
            closeOnSelect: false,
            dateFormat: 'yyyy-MM-dd',
            showTodayButton: true,
            templateType: 'modal'
        };
        var ipObj2 = {
            callback: function(val) {
                $scope.data.endtime = $filter('date')(new Date(val), 'yyyy-MM-dd');
                $scope.endtime = val;
                var date = $scope.endtime - $scope.starttime;
                var days = Math.floor(date / (24 * 3600 * 1000));
                $scope.data.days = days;
            },
            disabledDates: [

            ],
            titleLabel: '',
            from: new Date(),
            to: new Date().setYear(new Date().getFullYear() + 1),
            inputDate: new Date(),
            mondayFirst: false,
            //disableWeekdays: [0],
            closeOnSelect: false,
            dateFormat: 'yyyy-MM-dd',
            showTodayButton: true,
            templateType: 'modal'
        };

        $scope.openDatePicker = function(obj) {
            if (obj == 'starttime') {
                ionicDatePicker.openDatePicker(ipObj1);
                $scope.getprice();
            };
            if (obj == 'endtime') {
                ionicDatePicker.openDatePicker(ipObj2);
                $scope.getprice();
            };
        };
        $scope.getdays = function() {
            var date1 = $scope.data.starttime; //开始时间
            var date2 = $scope.data.endtime; //结束时间
            //console.log(date1);
            var date3 = date2.getTime() - date1.getTime(); //时间差的毫秒数
            var days = Math.floor(date3 / (24 * 3600 * 1000)); //计算出相差天数
            $scope.data.days = days;
            //console.log(days);
        };
        //动态调整价格
        $scope.getprice = function() {
            var days=$scope.data.days;
            var price=0;
            if (days>=1&&days<=2) {
                price=20;
            }else if (days>=3&&days<=4) {
                price=30;
            }else if (days>=5&&days<=6) {
                price=40;
            }else{
                price=50
            };
            $scope.data.price = price;
            //console.log(price);
        };
        $scope.isuntime = function() {
            var isChecked = $scope.data.isuntime;
            if (isChecked) {
                $('.cxts').show();
                $('.gjl_chufa_time').hide();
            } else {
                $('.cxts').hide();
                $('.gjl_chufa_time').show();
            }
        };
        $scope.location_province = function(page, backcount) {
            $state.go('location_province', { page: page, backcount: backcount });
        }
    })
    //抢单列表
    .controller('GrabCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $http, $state, $ionicActionSheet, sqlite, $stateParams, ls) {
        var access_token = ls.get('access_token');
        var page = 1;
        var PAGESIZE = 20;

        var obj = {};
        obj.params = {};
        obj.params.page = page;
        obj.params.pagesize = PAGESIZE;
        $scope.items = [];

        $scope.$on('$ionicView.enter', function() {
            if ($rootScope.detailShow) {
                $rootScope.detailShow = false;
                return false;
            };
            $scope.refresh();
        });

        init_Grab = function() {
            obj.params.page = page = 1;
            $scope.isNull = false;
            $scope.isMore = false;
            $scope.moredata = false;
            $scope.items = [];
        };

        $scope.refresh = function() {
            init_Grab();
            loading.show($ionicLoading);
            $http.jsonp(url + '/api/app/order.php?action=singlegrablist&callback=JSON_CALLBACK', obj).success(function(result) {
                var list = result.list;
                console.log(list);
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].userid) == 'undefined') {
                        $scope.isNull = true;
                        $scope.isMore = false;
                        $scope.moredata = false;
                        $scope.nodata = '陛下，恕微臣无能，暂未找到已发布的需求！';
                        break;
                    }
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    if (list.length == PAGESIZE) {
                        $scope.isMore = true;
                        $scope.moredata = true;
                        page++;
                    } else {
                        $scope.isMore = false;
                        $scope.moredata = false;
                    }
                }
                $scope.$broadcast('scroll.refreshComplete');
                loading.hide($ionicLoading);
            });
        }

        $scope.loadMore = function() {
            if (!$scope.moredata) return;
            loading.show($ionicLoading);
            obj.params.page = page;
            $http.jsonp(url + '/api/app/order.php?action=singlegrablist&access_token=' + access_token + '&callback=JSON_CALLBACK', obj).success(function(result) {
                var list = result.list;
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].userid) == 'undefined') {
                        break;
                    } else {
                        $scope.items.push(list[i]);
                    }
                };
                if (list.length == PAGESIZE) {
                    $scope.isMore = true;
                    $scope.moredata = true;
                    page++;
                } else {
                    $scope.isMore = false;
                    $scope.moredata = false;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                loading.hide($ionicLoading);
            });
        };
        //抢单
        $scope.grab = function(orderid) {
            //waiting.show($ionicLoading);
            var confirmPopup = $ionicPopup.confirm({
                title: ALERT_TITLE,
                template: "抢单成功后要及时设计行程，您确定要抢单吗？",
                okText: '确定',
                okType: 'button-balanced',
                cancelText: '取消'
            });
            confirmPopup.then(function(res) {
                if (res) {
                    $scope.data = [];
                    $scope.data.orderid = orderid;
                    $.ajax({
                        url: url + '/api/app/order.php?action=singlegrab&access_token=' + access_token + '&orderid=' + orderid,
                        type: 'post',
                        timeout: HTTP_TIMEOUT,
                        async: true,
                        data: $scope.data,
                        dataType: 'json',
                        complete: function(XMLHttpRequest, status) {
                            //waiting.hide($ionicLoading);
                        },
                        success: function(data) {
                            var alertPopup = $ionicPopup.alert({
                                title: ALERT_TITLE,
                                template: data.strmsg,
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                            if (data.code == "1") {
                                alertPopup.then(function(res) {
                                    $rootScope.notdesigner = 0;
                                    $rootScope.notdesignertitle = '我要设计详情';
                                    $state.go('mycenter_mydesigngrabdetails', { id: orderid });
                                });
                            };
                        },
                        error: function(XMLHttpRequest, textStatus, errorThrown) {
                            var text;
                            text = textStatus;
                            if (textStatus == 'timeout') {
                                text = TEXT_STATUS_TIMEOUT;
                            };
                            if (textStatus == 'error') {
                                text = TEXT_STATUS_ERROR;
                            };
                            var alertPopup = $ionicPopup.alert({
                                title: ALERT_TITLE,
                                template: text,
                                buttons: [{ text: BUTTON_TEXT_CLOSE, type: 'button-balanced' }]
                            });
                        }
                    });
                } else {
                    console.log('You are not sure');
                }
            });
        };
        $scope.grab_details = function(id) {
            $state.go('grab_details', { id: id });
        };

    })
    //偷看列表
    .controller('PeekCtrl', function($scope, $rootScope, $ionicLoading, $ionicModal, $ionicPopup, $http, $state, $ionicActionSheet, sqlite, $stateParams, ls) {
        var access_token = ls.get('access_token');
        var page = 1;
        var PAGESIZE = 20;

        var obj = {};
        obj.params = {};
        obj.params.page = page;
        obj.params.pagesize = PAGESIZE;
        $scope.items = [];

        $scope.$on('$ionicView.enter', function() {
            if ($rootScope.detailShow) {
                $rootScope.detailShow = false;
                return false;
            };
            $scope.refresh();
        });

        init_Peek = function() {
            obj.params.page = page = 1;
            $scope.isNull = false;
            $scope.isMore = false;
            $scope.moredata = false;
            $scope.items = [];
        };

        $scope.refresh = function() {
            init_Peek();
            loading.show($ionicLoading);
            $http.jsonp(url + '/api/app/plans.php?action=hot&access_token=' + access_token + '&callback=JSON_CALLBACK', obj).success(function(result) {
                var list = result.list;
                console.log(list);
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].userid) == 'undefined') {
                        $scope.isNull = true;
                        $scope.isMore = false;
                        $scope.moredata = false;
                        $scope.nodata = '您想要的设计师/规划师正在努力修炼中….';
                        break;
                    }
                }
                if (!$scope.isNull) {
                    $scope.items = list;
                    if (list.length == PAGESIZE) {
                        $scope.isMore = true;
                        $scope.moredata = true;
                        page++;
                    } else {
                        $scope.isMore = false;
                        $scope.moredata = false;
                    }
                }
                $scope.$broadcast('scroll.refreshComplete');
                loading.hide($ionicLoading);
            });
        }

        $scope.loadMore = function() {
            if (!$scope.moredata) return;
            loading.show($ionicLoading);
            obj.params.page = page;
            $http.jsonp(url + '/api/app/plans.php?action=hot&access_token=' + access_token + '&callback=JSON_CALLBACK', obj).success(function(result) {
                var list = result.list;
                for (var i = 0; i < list.length; i++) {
                    if (typeof(list[i].userid) == 'undefined') {
                        break;
                    } else {
                        $scope.items.push(list[i]);
                    }
                };
                if (list.length == PAGESIZE) {
                    $scope.isMore = true;
                    $scope.moredata = true;
                    page++;
                } else {
                    $scope.isMore = false;
                    $scope.moredata = false;
                }
                $scope.$broadcast('scroll.infiniteScrollComplete');
                loading.hide($ionicLoading);
            });
        };
        //偷看
        $scope.pay = function(obj) {
            var data = {
                planid: obj.planid,
                ordertype: 'ordercopy',
                userid: obj.userid,
                nickname: obj.nickname,
                title: obj.title,
                headimgurl: obj.headimgurl,
                price: obj.price,
                keywords: obj.keywords
            };
            $rootScope.pay = data;
            $state.go('pay');
        };
        //查看
        $scope.schedule_details = function(id) {
            $state.go('schedule_details', { id: id });
        };
    })
    //抢单详情
    .controller('GrabDetailsCtrl', function($scope, $rootScope, $ionicPopup, $http, $state, $ionicActionSheet, sqlite, $stateParams, ls, $cordovaCamera, Camera) {
        var access_token = ls.get('access_token');
        var id = typeof($stateParams.id) == 'undefined' ? '' : $stateParams.id;
        console.log($rootScope.notdesigner);
        if ($rootScope.notdesigner == 1) {
            $http.jsonp(url + '/api/app/order.php?action=show&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                $scope.data = data;
                console.log(data);
            });
        } else {
            $http.jsonp(url + '/api/app/order.php?action=show&user=designer&id=' + id + '&access_token=' + access_token + '&callback=JSON_CALLBACK').success(function(data) {
                $scope.data = data;
                console.log(data);
            });
        }

    })
