angular.module('services', ['lokijs'])

.factory('update', ['$window', function($window) {
  //
}])

.factory('ls', ['$window', function($window) {
  return {
    set: function(key, value) {
      $window.localStorage[key] = value;
    },
    get: function(key, defaultValue) {
      return $window.localStorage[key] || defaultValue;
    },
    setObject: function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    },
    getObject: function(key) {
      return JSON.parse($window.localStorage[key] || '{}');
    },
    isNull: function(value) {
      return (typeof(value) == 'undefined' || value == '')?true:false;
    }
  }
}])

.factory('sqlite', ['$q', 'ls', function($q, ls){
  var db = null;
  var results = null;

  return {
    executeSql: function(sql) {
      document.addEventListener("deviceready", function onDeviceReady() {
        db = window.sqlitePlugin.openDatabase({name: "data\\my.db3"});
        db.transaction(function(zl) {
          zl.executeSql(sql);
        });
      }, false);
    },
    loadData: function(){
      document.addEventListener("deviceready", function onDeviceReady() {
        db = window.sqlitePlugin.openDatabase({name: "data\\my.db3"});
        db.transaction(function(zl) {
          zl.executeSql("CREATE TABLE IF NOT EXISTS user (id integer primary key, member text, access_token text, expires_in integer, islogin boolean, location text, city text)");
          zl.executeSql("select * from user", [], function(zl, res) {
            if (res.rows.length > 0) {
              var row = res.rows.item(0);
              for(var j in row){
                ls.set(j, row[j]);
              }
            };
          }, function(e) {
            
          });
        });
      }, false);
    },
    saveData: function(data) {
      document.addEventListener("deviceready", function onDeviceReady() {
        db = window.sqlitePlugin.openDatabase({name: "data\\my.db3"});
        db.transaction(function(zl) {
          zl.executeSql("CREATE TABLE IF NOT EXISTS user (id integer primary key, member text, access_token text, expires_in integer, islogin boolean, location text, city text)");
          zl.executeSql("select * from user", [], function(zl, res) {
            var obj = {
              member: '',
              access_token: '',
              expires_in: '',
              islogin: '',
              location: '',
              city: ''
            };
            if (res.rows.length > 0) {
              if (data.islogin == false) {
                zl.executeSql("DELETE FROM user WHERE id>0");
              }
              else {
                var row = res.rows.item(0);
                obj.member = ls.isNull(data.member) ? row['member'] : JSON.stringify(data.member);
                obj.access_token = ls.isNull(data.access_token) ? row['access_token'] : data.access_token;
                obj.expires_in = ls.isNull(data.expires_in) ? row['expires_in'] : data.expires_in;
                obj.islogin = ls.isNull(data.islogin) ? row['islogin'] : data.islogin;
                obj.location = ls.isNull(data.location) ? row['location'] : JSON.stringify(data.location);
                obj.city = ls.isNull(data.city) ? row['city'] : JSON.stringify(data.city);
                zl.executeSql("UPDATE user SET member=?, access_token=?, expires_in=?, islogin=?, location=?, city=? WHERE id>0",
                  [obj.member, obj.access_token, obj.expires_in, obj.islogin, obj.location, obj.city]);
              };
            }
            else {
              obj.member = ls.isNull(data.member) ? '' : JSON.stringify(data.member);
              obj.access_token = ls.isNull(data.access_token) ? '' : data.access_token;
              obj.expires_in = ls.isNull(data.expires_in) ? '' : data.expires_in;
              obj.islogin = ls.isNull(data.islogin) ? '' : data.islogin;
              obj.location = ls.isNull(data.location) ? '' : JSON.stringify(data.location);
              obj.city = ls.isNull(data.city) ? '' : JSON.stringify(data.city);
              zl.executeSql("INSERT INTO user (member, access_token, expires_in, islogin, location, city) VALUES (?,?,?,?,?,?)", [obj.member, obj.access_token, obj.expires_in, obj.islogin, obj.location, obj.city]);
              
            };
            ls.set('member', obj.member);
            ls.set('access_token', obj.access_token);
            ls.set('expires_in', obj.expires_in);
            ls.set('islogin', obj.islogin);
            ls.set('location', obj.location);
            ls.set('city', obj.city);
          });
        });
      }, false);
    },
  }
}])

.factory('appConfig', ['$q', 'Loki', 'ls', function($q, Loki, ls) {
  var q = $q.defer();
  //var db = new PouchDB('version', {adapter: 'websql'});

  /*return {
    getNumber: function() {
      //return $q.when(db.get('1'));
      db.get('1', function(err, result) {
         if (err) {
            q.reject(err);
         } else {
            q.resolve(result);
         }
      });
      return q.promise;
    },
    setNumber: function(number) {
      var data = {_id: '1', number: number};
      //var data = {number: data.number, _rev: data._rev};
      //return $q.when(db.put(data));
      db.put(data, function(err, response) {
         if (err) {
            q.reject(err);
            console.log(err);
         } else {
            q.resolve();
            console.log("Document created Successfully");
         }
      });
      return q.promise;
    },
    destroy: function() {
      console.log('destroy');
      return $q.when(db.destroy());
    }
  }*/

  var adapter = new LokiCordovaFSAdapter({"prefix": "loki"});
  var db = new Loki('config.json',
                    {
                      autosave: true,
                      autosaveInterval: 1000, // 1 second
                      adapter: adapter
                    });
  var options = {};
  var _data;

  return {
    isFirstRun: function() {
      var boo = ls.get('isFirstRun');

      if (ls.isNull(boo)) {
        _data = db.getCollection('config');
        if (!_data) {
          boo = "true";
        }
        else {
          boo = "false";
        };
        ls.set('isFirstRun', boo);
      }
      
      return boo;
    },
    getFirstRun: function() {
      var boo = ls.get('isFirstRun');

      if (ls.isNull(boo)) {
        _data = db.getCollection('config');
        if (!_data) {
          boo = "true";
        }
        else {
          boo = "false";
        };
        ls.set('isFirstRun', boo);
      }

      q.resolve(boo);

      return q.promise;
    },
    setFirstRun: function(boo) {
      _data = db.getCollection('config');
      if (!_data) {
        _data = db.addCollection('config');
        _data.insert({isFirstRun: boo});
      }
      else {
        _data.data[0].isFirstRun = boo;
        _data.update(_data.data);
      };

      ls.set('isFirstRun', boo);
    }
  }

}])

.factory('Camera', ['$q', function($q) {
  return {
    getPicture: function(options) {
      var q = $q.defer();
      navigator.camera.getPicture(function(result) {
        q.resolve(result);
      }, function(err) {
        q.reject(err);
      }, options);

      return q.promise;
    }
  }
}])
