"use strict";

angular.module("ngTouch", [])
.directive("ngTouchstart", function () {
    return {
        controller: ["$scope", "$element", function ($scope, $element) {

            $element.bind("touchstart", onTouchStart);
            function onTouchStart(event) {
                var method = $element.attr("ng-touchstart");
                $scope.$event = event;
                $scope.$apply(method);
            }

        }]
    }
})
.directive("ngTouchmove", function () {
    return {
        controller: ["$scope", "$element", function ($scope, $element) {

            $element.bind("touchstart", onTouchStart);
            function onTouchStart(event) {
                event.preventDefault();
                $element.bind("touchmove", onTouchMove);
                $element.bind("touchend", onTouchEnd);
            }
            function onTouchMove(event) {
                var method = $element.attr("ng-touchmove");
                $scope.$event = event;
                $scope.$apply(method);
            }
            function onTouchEnd(event) {
                event.preventDefault();
                $element.unbind("touchmove", onTouchMove);
                $element.unbind("touchend", onTouchEnd);
            }

        }]
    }
})
.directive("ngTouchend", function () {
    return {
        controller: ["$scope", "$element", function ($scope, $element) {

            $element.bind("touchend", onTouchEnd);
            function onTouchEnd(event) {
                var method = $element.attr("ng-touchend");
                $scope.$event = event;
                $scope.$apply(method);
            }

        }]
    }
})
//评价
.directive("mystarselect", function($rootScope) {
    return {
        restrict: 'AE',
        replace: true,
        scope: {
            level: '=',
        },
        template: '<div id="mystarselect"></div>',
        link: function(scope) {
            function star5(starid) {
                var src = "images/";
                this.star_on_left = src + "star_on.png";
                this.star_off_left = src + "star_off.png";
                this.star_on_right = src + "star_on.png";
                this.star_off_right = src + "star_off.png";
                this.id = starid;
                this.point = 0;

                this.initial = starInitial;
                this.redraw = starRedraw;
                this.attach = starAttach;
                this.deattach = starDeAttach;
                this.doall = starDoall;
            }

            function starDoall(point) {
                this.initial();
                this.attach();
                this.redraw(point);
            }

            function starInitial() {
                var html = "" +
                    "<img id='star" + this.id + "_1' point='1' src='" + this.star_off_right + "'>&nbsp;";
                html += "<img id='star" + this.id + "_2' point='2' src='" + this.star_off_right + "'>&nbsp;";
                html += "<img id='star" + this.id + "_3' point='3' src='" + this.star_off_right + "'>&nbsp;";
                html += "<img id='star" + this.id + "_4' point='4' src='" + this.star_off_right + "'>&nbsp;";
                html += "<img id='star" + this.id + "_5' point='5' src='" + this.star_off_right + "'>" + "";
                //document.write(html);
                document.getElementById("mystarselect").innerHTML = html;
            }

            function starAttach() {
                for (var i = 1; i < 6; i++) {
                    document.getElementById("star" + this.id + "_" + i).style.cursor = "pointer";
                    document.getElementById("star" + this.id + "_" + i).onmouseover = moveStarPoint;
                    document.getElementById("star" + this.id + "_" + i).onmouseout = outStarPoint;
                    document.getElementById("star" + this.id + "_" + i).starid = this.id;
                    document.getElementById("star" + this.id + "_" + i).onclick = setStarPoint;
                }
            }

            function starDeAttach() {
                for (var i = 1; i < 6; i++) {
                    document.getElementById("star" + this.id + "_" + i).style.cursor = "default";
                    document.getElementById("star" + this.id + "_" + i).onmouseover = null;
                    document.getElementById("star" + this.id + "_" + i).onmouseout = null;
                    document.getElementById("star" + this.id + "_" + i).onclick = null;
                }
            }

            function starRedraw(point) {
                for (var i = 1; i < 6; i++) {
                    if (i <= point)
                        if (parseInt(i / 2) * 2 == i)
                            document.getElementById("star" + this.id + "_" + i).src = this.star_on_right;
                        else
                            document.getElementById("star" + this.id + "_" + i).src = this.star_on_left;
                    else if (parseInt(i / 2) * 2 == i)
                        document.getElementById("star" + this.id + "_" + i).src = this.star_off_right;
                    else
                        document.getElementById("star" + this.id + "_" + i).src = this.star_off_left;
                }
            }

            function moveStarPoint(evt) {
                var pstar = evt ? evt.target : event.toElement;
                var point = pstar.getAttribute("point");
                var starobj = new star5(pstar.starid);
                starobj.redraw(point);
            }

            function outStarPoint(evt) {
                /*var pstar = evt ? evt.target : event.srcElement;
                var starobj = new star5(pstar.starid);
                starobj.redraw(0);*/
            }

            function setStarPoint(evt) {
                var pstar = evt ? evt.target : event.srcElement;
                var starobj = new star5(pstar.starid);
                starobj.deattach();
                var n = pstar.getAttribute("point");
                $rootScope.ztpj = n;
                console.log("选择的等级:" + n);
                scope.level = n;
                starobj.doall(n);
            }

            var star = new star5("point");
            star.doall(0);
        }
    };
}).directive("mystarselect1", function($rootScope) {
    return {
        restrict: 'AE',
        replace: true,
        scope: {
            level: '=',
        },
        template: '<div id="mystarselect1"></div>',
        link: function(scope) {
            function star5(starid) {
                var src = "images/";
                this.star_on_left = src + "star_on.png";
                this.star_off_left = src + "star_off.png";
                this.star_on_right = src + "star_on.png";
                this.star_off_right = src + "star_off.png";
                this.id = starid;
                this.point = 0;

                this.initial = starInitial;
                this.redraw = starRedraw;
                this.attach = starAttach;
                this.deattach = starDeAttach;
                this.doall = starDoall;
            }

            function starDoall(point) {
                this.initial();
                this.attach();
                this.redraw(point);
            }

            function starInitial() {
                var html = "" +
                    "<img id='star1" + this.id + "_1' point='1' src='" + this.star_off_right + "'>&nbsp;";
                html += "<img id='star1" + this.id + "_2' point='2' src='" + this.star_off_right + "'>&nbsp;";
                html += "<img id='star1" + this.id + "_3' point='3' src='" + this.star_off_right + "'>&nbsp;";
                html += "<img id='star1" + this.id + "_4' point='4' src='" + this.star_off_right + "'>&nbsp;";
                html += "<img id='star1" + this.id + "_5' point='5' src='" + this.star_off_right + "'>" + "";
                //document.write(html);
                document.getElementById("mystarselect1").innerHTML = html;
            }

            function starAttach() {
                for (var i = 1; i < 6; i++) {
                    document.getElementById("star1" + this.id + "_" + i).style.cursor = "pointer";
                    document.getElementById("star1" + this.id + "_" + i).onmouseover = moveStarPoint;
                    document.getElementById("star1" + this.id + "_" + i).onmouseout = outStarPoint;
                    document.getElementById("star1" + this.id + "_" + i).starid = this.id;
                    document.getElementById("star1" + this.id + "_" + i).onclick = setStarPoint;
                }
            }

            function starDeAttach() {
                for (var i = 1; i < 6; i++) {
                    document.getElementById("star1" + this.id + "_" + i).style.cursor = "default";
                    document.getElementById("star1" + this.id + "_" + i).onmouseover = null;
                    document.getElementById("star1" + this.id + "_" + i).onmouseout = null;
                    document.getElementById("star1" + this.id + "_" + i).onclick = null;
                }
            }

            function starRedraw(point) {
                for (var i = 1; i < 6; i++) {
                    if (i <= point)
                        if (parseInt(i / 2) * 2 == i)
                            document.getElementById("star1" + this.id + "_" + i).src = this.star_on_right;
                        else
                            document.getElementById("star1" + this.id + "_" + i).src = this.star_on_left;
                    else if (parseInt(i / 2) * 2 == i)
                        document.getElementById("star1" + this.id + "_" + i).src = this.star_off_right;
                    else
                        document.getElementById("star1" + this.id + "_" + i).src = this.star_off_left;
                }
            }

            function moveStarPoint(evt) {
                var pstar = evt ? evt.target : event.toElement;
                var point = pstar.getAttribute("point");
                var starobj = new star5(pstar.starid);
                starobj.redraw(point);
            }

            function outStarPoint(evt) {
                /*var pstar = evt ? evt.target : event.srcElement;
                var starobj = new star5(pstar.starid);
                starobj.redraw(0);*/
            }

            function setStarPoint(evt) {
                var pstar = evt ? evt.target : event.srcElement;
                var starobj = new star5(pstar.starid);
                starobj.deattach();
                var n = pstar.getAttribute("point");
                $rootScope.wcsd = n;
                console.log("选择的等级:" + $rootScope.wcsd);
                scope.level = n;
                starobj.doall(n);
            }

            var star = new star5("point");
            star.doall(0);
        }
    };
});
